<?php 

class FR_Multimedia_InfoFile {

protected $ID3;

//HAY QUE MIRAR EL valor del array tags!!!

	
/* Passa un array que conte informacio del fitxer,
* Aquest array ha de ser donat per la classe scanFile 
*/

function __construct($info){	  
		
		$this->ID3 = $info;		
}

public function getFormat() {

	if(isset($this->ID3))	return $this->ID3['fileformat'];
	else return false;
}

/**
* Torna el nom del fitxer
* @return String
*/

public function getName() {

	if(isset($this->ID3))	return $this->ID3['filename'];
	else return false;	
}

/**
* Torna la ruta on estroba el fitxer
* @return String
*/

public function getPath() {

	if(isset($this->ID3))	return $this->ID3['filepath'];
	else return false;	
}

/**
* Tamany del fitxer
* @return Integer
*/

public function getSize() {

	if(isset($this->ID3))	return $this->ID3['filesize'];
	else return false;	
}

/**
* Tipus mime del fitxer
* @return String
*/
public function getMime(){

	if(isset($this->ID3))	return $this->ID3['mime_type'];
	else return false;
}

}


?>