<?php
/*
 *                      ScreenObject.php
 *                    ------------------
 * Creat            : 16-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 class FR_ScreenObject   {
  
  private $musicElement; /*Objeto, que se va a visualizar por pantalla. De tipo music element: Album, Artista, Genero , Cancion, playlist*/  
  private $observation; /* Objeto, Informacio de les observacions a visualitzar*/
  private $emotion;    	/* Objeto, Emociones a visualizar */
  private $userPlays; 	/*Entero, que informa del numero de repoducciones del objeto screen  un usuario */
  private $appplay; 	/*  Entero, que informa del numero de reproduciones realizaadas por todos los usuarios registrados en la aplicacion*/
  private $puntuation;  /* Puntuacion definida por el usuario $userID sobre el objeto musicElement.*/
  private $idUserUsePlay; /*Identificador de uso de reproduccion del elemento por el usuario actual*/
  private $lastPlayed; /* Almazena la fecha de la ltima vez que se reproduco una cancion.*/
  
  
      public function __construct($musicElement_)
      {
          //parent::__construct($class,$module,$actionClass);
          $this->musicElement = $musicElement_;           		
		  $this->observation = null; 
		  $this->emotion = null;    	
		  $this->userPlays = 0; 	
		  $this->appplay = 0; 	
		  $this->puntuation = 0; 
		  $this->idUserUsePlay = 0;      
      }	
  
  
    public function setMusicElement($attr ) {
    	$this->musicElement = $attr;
	}
	
    public function getMusicElement() {
    	if(isset($this->musicElement)) return $this->musicElement;
    	else return false;
	}
	
	public function setUserID($attr ) {
    	$this->userID = $attr;
	}
	
	public function getUserID() {
   	 	if(0 == $this->userID)	return $this->userID;
   	 	else return false;
	}
	
	public function setObservation ($attr ) {
    	$this->observation = $attr;
	}
	
	public function getObservation() {
    	if(isset($this->observation)) return $this->observation;
    	else return false;
	}
	
	public function setEmotion ($attr ) {
    	$this->emotion = $attr;
	}
	
	public function getEmotion () {
    	if(isset($this->emotion)) return $this->emotion;
    	else return false;
	}
	
	public function setUserPlays ($attr ) {
    	$this->userPlays = $attr;
	}
	
	public function getUserPlays () {
    	return $this->userPlays;
	}
	
	public function setAppPlay ($attr ) {
    	$this->appplay = $attr;
	}
	
	public function getAppPlay () {
    	return $this->appplay;
	}
	
	public function setPuntuation ($attr) {
    	$this->puntuation = $attr;
	}
	
	public function getPuntuation() {
    	return $this->puntuation;
    }
    
    public function setIdUserUsePlay ($attr ) {
    	$this->idUserUsePlay = $attr;
	}
	
	public function getIdUserUsePlay () {
    	return $this->idUserUsePlay;
    }
    
    public function setLastPlayedDate($atrr) {
    	$this->lastPlayed = $atrr;
    }
    
    public function getLastPlayedDate() {
    	return $this->lastPlayed;
    }
    
    
 
}
?>
