<?php

 /*
  * Par eliminar un warning que sale cuando creas sessiones
  * 
  * */
ob_start();


  /**
  * index.php
  *
  * @author Joe Stump <joe@joestump.net>
  * @copyright Joe Stump <joe@joestump.net>
  * @license http://www.opensource.org/licenses/gpl-license.php
  * @package Framework
  */

  require_once('config.php');
  require_once('PEAR.php');
  // {{{ __autoload($class)
  /**
  * __autoload
  *
  * Autoload is ran by PHP when it can't find a class it is trying to load.
  * By naming our classes intelligently we should be able to load most classes
  * dynamically.
  *
  * @author Joe Stump <joe@joestump.net>
  * @param string $class Class name we're trying to load
  * @return void
  * @package Framework
  */
  function __autoload($class)
  {  	
  	$type = substr($class,0,2);
  	  
	//echo "<br/>Valor del class: ".$class;	    
	  if("FR" == $type) /* Si es una classe propia del framework hay que cortar*/
	  {
      		$file = str_replace('_','/',substr($class,2)).'.php';      		
	  }
	  else $file = 'model/model/'.$class.'.php'; //PARA los objetos del model
	  	  	  	  
	//echo "<br/> Valor del fichero: ".$file;	   
      require_once(FR_BASE_PATH.'/includes/'.$file);      	  
  }
  // }}}
	
	
/**
 * Carga la pantalla que tiene que visualizarse.Despus de una canbio en el model.
 * */

  function showPresenter($instance,$message=null)  {
  	
  	 $presenter = FR_Presenter::factory($instance->presenter,$instance);
								
       if (!PEAR::isError($presenter)) {         
       		
       		if(isset($message)) $presenter->getModule()->set('message',$message);                   
            $presenter->display();
            
       } else {
              die($presenter->getMessage());
       }  	
  }


  if (!isset($_GET['module'])) { /*si no se ha especificado un modulo correcto volvemos al login */
  	
  	$module = 'users';
  	$_GET['class']= 'login';  	
  }  
  else $module = $_GET['module']; 
      
      if (isset($_GET['event'])) {
          $event = $_GET['event'];
      } else {
          $event = '__default';
      }

      if (isset($_GET['class'])) {
          $class = $_GET['class'];
      } else {
          $class = $module;
      }

      $classFile = FR_BASE_PATH.'/modules/'.$module.'/'.$class.'.php';    
   
      if (file_exists($classFile)) {    
      
          require_once($classFile);
          if (class_exists($class)) {          	
          		
              try {															/*erros was produced by  I N S T A N C E   C L A S S */
                             
                  $instance = new $class();
                  	
                  if (!FR_Module::isValid($instance)) {
                      
                      throw new Exception("Requested module is not a valid framework module!");
                      
                  }
                  $instance->moduleName = $module;
                  if ($instance->authenticate()) {
                      try {													/* Errors was produced by  E V E N T*/	
                          $result = $instance->$event();                
                         
                          if (!PEAR::isError($result)) {                        		
                          	     	showPresenter($instance);												
                          }
                      } catch (Exception $error) { /*La excepcion es lanzada por el evento */
                          
                          showPresenter($instance,$error->getMessage(),$error->getMessage());                          
                      }
                  } else {
                      throw new Exception("You do not have access to the requested page!");
                  }
              } catch (Exception $error) {						
                
                showPresenter($instance,$error->getMessage());    
              }
          } else {
              die("An valid module for your request was not found");        
          }
      }else {
          die("Could not find: $classFile");        
	}





?>
