<?php
/*
 * Created on 11-abr-2006
 *
 */
 
require_once(FR_BASE_PATH.'/modules/analyce/SaveSongs.php');
require_once('ConstAnalyce.php');
 
class directori extends FR_Auth_User {

private $songsOK; 		   /* Array: Almacena las canciones que tienen toda la informacion */
private $incompletSongs;   /* Array: Almacena las canciones que no tienen toda la informacion  */
private $incompatibleSong; /* Array: Guarda URL de canciones de audio no compatibles con el sistema */
private $errorFile;        /* Array: Guarda URL de ficheros con error. */
private $result;
private $count_; 			/* Cuenta el nmero de archivos analizados */


protected $sc;   			/*Objecto: ScanFile */


public function __construct() 	{
		 
	 
		 
        parent::__construct();		
		$this->sc = new FR_Util_ScanFile();		
		
		;	
	    /*
	    if (isset($_SESSION["result"])) {			
			$this->result =  unserialize($_SESSION["result"]);	
		}
		*/
		
		if (null != $this->session->result) { 
			
			$this->result =  unserialize($this->session->result);
		}	
		else $this->result = array();
		
		
		if (null !=$this->session->songsOK) $this->songsOK = unserialize($this->session->songsOK);
		else $this->songsOK = array();
		
		/*
		if (isset($_SESSION["songsOK"])) $this->songsOK = unserialize($_SESSION["songsOK"]);
		else $this->songsOK = array();
		*/
		
		/*
		if (isset($_SESSION["incompletSongs"])) $this->incompletSongs =  unserialize($_SESSION["incompletSongs"]);
		else $this->incompletSongs = array();
		*/		
		
		if (null != $this->session->incompletSongs) $this->incompletSongs =  unserialize($this->session->incompletSongs);
		else $this->incompletSongs = array();
			
		/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/
    	//$this->set('3_User_Info_colum','si');
		
		$this->incompatibleSong = array(); 
		$this->errorFile = array();				
		$this->count_= 0;	
		
}
	
/**
 * Metodo que es llamado cuando el usuario quiere empezar un anlisi.
 * 
 * */
 
public function __default() {
				
		/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/
    	//$this->set('3_User_Info_colum','si');
    	
		$directori = 'Indique la ruta donde se encuentra la musica a cargar';
		$this->set("lit_analyce",$this->getLiteral(FR_Util_Literals::LIT_ANALYZE));
		$this->set("lit_browse",$this->getLiteral(FR_Util_Literals::LIT_BROWSE)); 
		$this->set('directoris',$directori);						
}

/*
 * PASO 1-- comprueba que tengamos acceso al directorio entrado.
 * 
 * */
public function print_wait() {
	
				
		//echo "PATH:".$_GET['path'];
		$path = $_GET['path'];		
		$path = FR_Util_Miscelanea::convertToUnixSlash($path);	
		
		if (!@chdir($path)){			
		
			$this->set('message','Directori no accesible');
			$this->__default();			
		}
		else { /* Start analyce */
			
			$action = 'onLoad="JavaScript:document.forms['."'"."frm"."'".'].submit()"'; 
			$this->set('action_autoload',$action);
			$this->set('message',$this->getLiteral(ConstAnalyce::LIT_ANAL_STEP_1));
			$this->set('message2',$this->getLiteral(ConstAnalyce::LIT_ANAL_STEP_2));
			$this->set('p',urlencode($path));
			$this->tplFile='printwait.tpl';
			//$this->pageTemplateFile = 'autoload.tpl';			
		}
	
}
	
/**
 * Inicia el analisi de un directorio y de todo su contendio.
 * 
 * */
public function start_analyce() {

		echo "<br>Print_Analyce:".$_GET['path'];
		$path = urldecode($_GET['path']);		
				
		$starttime = FR_Util_Miscelanea::getmicrotime();
		
	    $this->analyceDirectory($path);
		
		$endtime = FR_Util_Miscelanea::getmicrotime();
		$time_analisi = number_format($endtime - $starttime, 3);										
		
	    /* Guardar arrays en la session */
		//$_SESSION["songsOK"] = serialize($this->songsOK);
		//$_SESSION["incompletSongs"] = serialize($this->incompletSongs);
		
		$this->session->songsOK = serialize($this->songsOK);
		$this->session->incompletSongs = serialize($this->incompletSongs);	
		
		/* Numero de archivos analizados */
		$this->set('num_files',$this->count_);	
		
		/*Calculo de resultados del analisis */
		$completeSong = count($this->songsOK);
		$incompleteSong = count($this->incompletSongs);
		
		$action = 'onLoad="JavaScript:document.forms['."'"."frm"."'".'].submit()"';
		$this->set('action_autoload',$action);

		$this->result['message'] = $this->getLiteral(ConstAnalyce::LIT_ANAL_STEP_1); 
		$this->result['message2'] =$this->getLiteral(ConstAnalyce::LIT_ANAL_STEP_2);
		$this->result['num_files'] = $this->count_;
		$this->result['comp_files'] = $completeSong + $incompleteSong;  /* Audio compatibles*/
		$this->result['complets'] = $completeSong;						/* Canciones completas*/
		$this->result['incomplets'] = $incompleteSong;					/* Canciones Incompletas*/
		$this->result['inc_files'] = count($this->incompatibleSong);    /* Audio incompatible */
		$this->result['err_files'] = count($this->errorFile);           /* Archivos con error */
		$this->result['time_analisi'] = $time_analisi;
		
		
		$this->result["lit_info_files"] = $this->getLiteral(ConstAnalyce::LIT_INFO_FILES);
		$this->result["lit_info_analyzed"]  = $this->getLiteral(ConstAnalyce::LIT_INFO_ANALYZED);
		$this->result["lit_info_comp_audio"] = $this->getLiteral(ConstAnalyce::LIT_INFO_COMP_AUDIO);
		$this->result["lit_info_completes"] = $this->getLiteral(ConstAnalyce::LIT_INFO_COMPLETES);
		$this->result["lit_info_incompletes"] = $this->getLiteral(ConstAnalyce::LIT_INFO_INCOMPLETES);
		$this->result["lit_info_incomp_audio"] = $this->getLiteral(ConstAnalyce::LIT_INFO_INCOMP_AUDIO);
		$this->result["lit_info_error_files"] = $this->getLiteral(ConstAnalyce::LIT_INFO_ERROR_FILES);
		
		$this->result["lit_info_result_analyce"] = $this->getLiteral(ConstAnalyce::LIT_INFO_RESULT_ANALYCE);		
		$this->result["lit_seconds"] = $this->getLiteral(ConstAnalyce::LIT_SECONDS);
		
		$this->array_set($this->result);	
		
		$this->session->delete("result");
		
		$this->session->result = serialize($this->result);
		
		$this->tplFile = "endAnalyce.tpl";	//selecion de plantilla
		//$this->pageTemplateFile = 'autoload.tpl';		
		//$this->pageTemplateFile = 'autoload.tpl';
		
}

/**
 * Inicia el guardar a la Base de datos las canciones analizadas 
 */	
public function saveDB() {

$r1 = array();
$r2 = array();


//Comprovamos que hay canciones completeas correctas
$starttime = FR_Util_Miscelanea::getmicrotime();
 

if($this->songsOK[0] instanceof FR_Util_TmpSong) $r1 = $this->completeSongs();			
if($this->incompletSongs[0] instanceof FR_Util_TmpSong) $r2 = $this->incompleteSongs();
   	
$endtime = FR_Util_Miscelanea::getmicrotime();		
$time_saveDB = number_format($endtime - $starttime, 3);

$this->songParser($r1);
$this->songParser($r2);
$this->calculResults();

$this->result["lit_info_new_albums"] = $this->getLiteral(ConstAnalyce::LIT_INFO_NEW_ALBUMS);
$this->result["lit_info_new_artists"] = $this->getLiteral(ConstAnalyce::LIT_INFO_NEW_ARTISTS);
$this->result["lit_info_new_songs"] = $this->getLiteral(ConstAnalyce::LIT_INFO_NEW_SONGS);
$this->result["lit_info_repeat_songs"] = $this->getLiteral(ConstAnalyce::LIT_INFO_REPEAT_SONGS);
$this->result["lit_info_size"] = $this->getLiteral(ConstAnalyce::LIT_INFO_SIZE);
$this->result["lit_info_music_time"] = $this->getLiteral(ConstAnalyce::LIT_INFO_MUSIC_TIME);
$this->result["lit_info_result_saved"] = $this->getLiteral(ConstAnalyce::LIT_INFO_RESULT_SAVED);

$this->result["lit_seconds"] = $this->getLiteral(ConstAnalyce::LIT_SECONDS);

$this->result['time_saveDB'] = $time_saveDB;

/* Configuracion Pantalla */

$this->array_set($this->result);
$this->tplFile = "endSaveDB.tpl";	

	
/* 
 * borramos las variables de session por si vuelven hacer un proceso de analisis
 * no haya residuos.
 * */

$this->session->delete("result");
$this->session->delete("songsOK");
$this->session->delete("incompletSongs");
}	
	
	
/**
 * Guarda las cancions   
 **/
 
private function completeSongs() {

$save = new SaveSongs();	
	
	$this->songParser($save->completeSongs($this->songsOK)); //Cancons OK i cancons NOK	
		
}

/*
 * Parsear el resultado de grabar en la BD. Con los resultados
 * del directorio 
 * */

private function songParser($res) {

	if(is_array($res)) {
		
		foreach($res as $key=> $value) {		
			$this->result[$key] += $value;
		}
}
}

private function resultSaveParser($res)
{
	if(isset($this->result['num_albums']))  $this->result['num_albums'] += $res['num_albums'];
	else $this->result['num_albums'] = $res['num_albums'];
	
	if(isset($this->result['num_songs'])) $this->result['num_songs'] += $res['num_songs'];
	else $this->result['num_songs'] = $res['num_songs'];
	
	if(isset($this->result['num_rep_songs'])) $this->result['num_rep_songs'] += $res['num_rep_songs'];
	else $this->result['num_rep_songs'] = $res['num_rep_songs'];
	
	if(isset($this->result['size'])) $this->result['size'] += $res['size'];
	else $this->result['size'] = $res['size'];
	
	if(isset($this->result['time'])) $this->result['time'] += $res['time'];	
	else $this->result['time'] = $res['time'];	
}

private function calculResults(){

/* Calculo de la unidad de tamanyo  */

if($this->result['size']  > 1073741824) {  /* G I G A B Y T E S  */
		
			$this->result['size'] =  FR_Util_Maths::getGigas($this->result['size']);
			$this->result['unitat'] = 'GB';	
}
else {   /* M E G A B Y T E S */
			$this->result['size'] =  FR_Util_Maths::getMegas($this->result['size']);
			$this->result['unitat'] = 'MB';						
}		
	
}
	
private function incompleteSongs() {
	
$save = new SaveSongs();	

  $this->songParser($save->inCompleteSongs($this->incompletSongs)); //cancons NOK 		
}



/**
 * Entran los datos de una cancion manualmente.El usuario.
 * 
 * */	
private function ManualInfo() {
		
		
}


public function analyceFile($full_file) {
		
	/* Importante comillas simples */		
		
 $file_size = @filesize($full_file); //bytes
		
		if($file_size) {//Comprovamos si hay informacion por leer
		
			if($this->sc->scanfile($full_file)) {			
											
				if($this->isOkFormat($this->sc->getFormatoMultimedia())) {				
								
					$mult_file =  FR_Multimedia::factory($this->sc->getMetaInfoTags(),$this->sc->getInfofile());			
					if(!PEAR::isError($mult_file)) {
								
						$tmp_song = new FR_Util_TmpSong();
						/* Posar la informacio en objecte */
							
		        		if($this->ompliCanco($tmp_song,$mult_file)) {			
							$this->songsOK[] = $tmp_song;																												
						 }					
						else $this->incompletSongs[] = $tmp_song;
					  }				 					  			
					  else { 
					     echo "ERROR".PEAR::isError($mult_file);					     
					     $this->incompatibleSong [] = $full_file;
					  }					  
				   }
				   else $this->incompatibleSong[]=$full_file;			
			     }	  				  
				 else $this->errorFile[]=$full_file;				   	
		}//fin de if control de tamanyo
		else $this->errorFile[]=$full_file;
			
/* Liberemos memoria */		
unset($tmp_song);
	
}
public function analyceDirectory($path)	{

$handle = opendir($path);								
		
	while ( false !== ( $file = @readdir($handle) ) ) {		
			
		
		// Prevent the script from timing out
		set_time_limit(0);
		$failed_check = false;
			
		if (is_link($file)) { //En Windows no hace nada con los links 
				
				$failed_check = true;
				$this->errorFile[] = $path;				
		}			
		/* if not .. or . */
		if ($file != "." AND $file != ".." AND !$failed_check) {			
				
			/* Change the dir so is_dir works correctly 				
			MIRAR MAS PARA DELANTE!!!!!, si es un directorio assegura que puedes cambiar. */
			if (!@chdir(stripslashes($path))) { /*Comprueba que tiene acces a un directorio */
					
				echo "<br/>METODE:analitzarDirectori CLASS:directori, ERROR: No tenim acces al directori" ;
			}
						
			/* Create the new path */
				$full_file = stripslashes($path."/".$file);
				$full_file = str_replace("//","/",$full_file);
				
				if (is_dir($full_file)) {						
					$this->analyceDirectory($full_file);
				} //it's a directory				
				else 
				{ 									
					$this->analyceFile($full_file);																
					$this->count_++;				 									
				}// fi else is file			
										
			}//fin control de . y ..		
			
		}// Fi while	
			
    @closedir($handle);	


return true; /* TODO ha salido correctamete */
		
}//fi funcio recorreDirectori

public function vis()
{
    echo "</br>RESULTATS INVESTIGACIO</br>";
    echo "</br>Nmero archius analitzats:".$this->count_;
    echo "</br> Arxius amb disc ID:</br>".$this->result;
    echo "</br>Arxius amd disc ID:<br/>";
    echo "</br>-----------------------------------<br/>";    
    $this->visualizar($this->songsOK);		
}


/**
 * Dice si el tipo de fihero multimedia esta soportado por la aplicacin
 * @return boolean true si el formato es vlido para el sistema, false en caso contrario
 */	
private function isOkFormat($format){
		
		$formats = include(MULTIMEDIA_DIR.'config.php');
		if(array_key_exists($format,$formats)) return true;		
		return false;
		//echo "<br/>array exist".array_key_exists($format,$formats);				
		
}
	
private function visualizarCano2($arr) {

       foreach( $arr as $key => $value ) {	   
	   			
               echo "<br/><br/><b> Fixtxer ".$key."</b>";
               $value->visualitzar();				   
       }
}

private function visualizar($arr) {

       foreach( $arr as $key => $value ) {	   
	   		 echo "<br/><br/><b> ".$key." -- ".$value."</b>";               			   
       }
}
	
private function ompliCanco(&$tmp_canco,&$mult_file) {

$completa = true;
		
	if($mult_file->getArtist()) $tmp_canco->setArtista($mult_file->getArtist());
	else {
		$tmp_canco->setArtista(null);
		$completa = false;	
	}
			
	if($mult_file->getAlbum()) $tmp_canco->setAlbum($mult_file->getAlbum());
    else {
		$tmp_canco->setAlbum(null);
		$completa = false;	
	}
		
	if($mult_file->getGenere()) $tmp_canco->setGenere($mult_file->getGenere());
	else {
		$tmp_canco->setGenere(null);
		$completa = false;	
	}
	
	if($mult_file->getTitle()) $tmp_canco->setNomCanco($mult_file->getTitle());	
	else {
		$tmp_canco->setNomCanco(null);
	$completa = false;	
	}
	
	if($mult_file->getTrack()) $tmp_canco->setTrack($mult_file->getTrack());
	else {
		$tmp_canco->setTrack(null);
		$completa = false;	
	}
	
	if($mult_file->getYear()) $tmp_canco->setAnyAlbum($mult_file->getYear());
	else {
		$tmp_canco->setAnyAlbum(null);
		$completa = false;	
	}
	
	/* El tag ja controlo si estaba escrita o no la imagen */
	
	$tmp_canco->setImage($mult_file->isImage());

		

	
	/* Aquesta informaci ser sempre certa si no s'ha produit cap error en la lectura del fitxer*/	
	if($mult_file->getPath()) $tmp_canco->setUrlArxiu($mult_file->getPath());		
	if($mult_file->getPlayTime()) $tmp_canco->setDuracio($mult_file->getPlayTime());		
	if($mult_file->getName()) $tmp_canco->setNomArxiu($mult_file->getName());	
	if($mult_file->getSize()) $tmp_canco->setTamanyArxiu($mult_file->getSize());	
	if($mult_file->getBitRate()) $tmp_canco->setBitrate($mult_file->getBitRate());	
	if($mult_file->getFormat()) $tmp_canco->setFormat($mult_file->getFormat());	
	if($mult_file->getMime()) $tmp_canco->setMime($mult_file->getMime());
	if($mult_file->getMode()) $tmp_canco->setMode($mult_file->getMode());
	if($mult_file->getRate()) $tmp_canco->setRate($mult_file->getRate()); /* Freqencia */	
			
return $completa;
}

	/**
	* Cerca arxius d'audio a partir d'una ruta definida. 
	*  Recull els fitxers amb error, els que no tenen el format suportat les cancon completes y les incompletes.
	*  @author J.Emilio Navarro
	*  @param String $path, Ruta on es vol comenar a buscar directoris. 
	*  @return 
	**/
	
	
		/* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }

	
public function __destruct()
{
          parent::__destruct();
          
          /*Liberamos memoria arrays*/
          unset($this->songsOK);          
          unset($this->incompletSongs);
          unset($this->incompatibleSong);
          unset($this->errorFile);
          unset($this->result);         
} 	
 	
 }  
 
 
 
?>
