<?php
/*
 *                        languages.php
 *                    ------------------
 * Creado            : 04-jun-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 require_once('propel/util/Criteria.php');
 class languages extends FR_Auth_No {	
	 
	 const CAT = 1; 
  	 const ESP = 2;
  	 const ENG = 3;
  	 
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
  		//echo "MAXIMO LITERAL".$this->getMaxIdLiteral(); 
  	   	
  	   	/* Siguiente literal ha introducir. */
  	   	$max = $this->getMaxIdLiteral();
  	   	if($max) /*Comprobacion de que no hay errores  */ {
  	   	
  	   		$this->set('idLiteral',$max + 1);
      		$this->set('button_action','alta');  	   		
  	   	}
      	else{ /* Error de base de datos */
      		$this->set('message',$this->getLiteral(FR_Util_GenericLiterals::DB_CONNECTION_ERROR));
      		//$this->tplFile='error.tpl';
      	}
      	
      	//$this->set('p',urlencode($path));
		
		//$this->pageTemplateFile = 'autoload.tpl';	
      }
      
      public function alta()
      {
  		$message = "Literales dados de alta correctamente.";
  		$error_mesage = ""; 	
  		
  		if(!$this->insertLanguage(self::CAT,$_POST['idLiteral2'],$_POST['cat'])) $error_mesage=" CAT, "; /* Catalan */
  		$this->saveFileInsertDB(self::CAT,$_POST['idLiteral2'],$_POST['cat']);
  	
  		
		if(!$this->insertLanguage(self::ESP,$_POST['idLiteral2'],$_POST['esp'])) $error_mesage=" ESP, "; /* Espaol */
		$this->saveFileInsertDB(self::ESP,$_POST['idLiteral2'],$_POST['esp']);
	
		
		if(!$this->insertLanguage(self::ENG,$_POST['idLiteral2'],$_POST['eng'])) $error_mesage=" ENG ";; /* Ingles */
		$this->saveFileInsertDB(self::ENG,$_POST['idLiteral2'],$_POST['eng']);
		
		/* Generacio de codi per programar mes rpid... ;-) */
		
		$this->saveConstFile($_POST['idLiteral2'],$_POST['info_literal']);
  		$this->saveScreenCode($_POST['idLiteral2'],$_POST['info_literal']);
		
		if("" == $error_mesage){ 				/* No hay errores de acceso */
			$this->set('message',$message);
			$this->set('idLiteral',$_POST['idLiteral2']+1);
		}
		else {
			$this->set('$error_mesage',"Literales incorectos:$error_mesage");
			$this->set('idLiteral',$_POST['idLiteral2']);
			$this->set('cat',$_POST['cat']);
			$this->set('esp',$_POST['esp']);
			$this->set('eng',$_POST['eng']); 
		} 
		
  		$this->set('button_action','alta');     
      }
      
      
      public function modificar() {
      	
      try {	
      	
      	echo "fasfasf:".$_POST['idLiteral1'];
      	
      	$cat = &$this->selectLiterals(self::CAT,$_POST['idLiteral2']);
      	$cat->setLiteral($_POST['cat']);      	
      	$cat->save();
      	$this->set('cat',$cat->getLiteral());
      	echo "CATALA:".$cat->getLiteral();
      	unset($cat);
      	
      	$esp = &$this->selectLiterals(self::ESP,$_POST['idLiteral2']);
      	$esp->setLiteral($_POST['esp']);      	
      	$esp->save();
      	$this->set('esp',$esp->getLiteral());
      	echo "ESPAOL:".$esp->getLiteral();
      	unset($esp);
      	
      	$eng = &$this->selectLiterals(self::ENG,$_POST['idLiteral2']);	      	
		$eng->setLiteral($_POST['eng']);
		echo "ANGLES:".$eng->getLiteral();
		$this->set('eng',$eng->getLiteral());
		$eng->save();
      	unset($eng);          	
	
		
		$this->set('idLiteral',$_POST['idLiteral2']);		
		$this->set('button_action','modificar');
		
		/*Liberar memoria */

      	
      }
      catch (PropelException $ex){
      	
      	$this->tplFile='error.tpl';
      	$this->set('message',$ex->getCause()); 
      }
      	
      }      
     
     /*
      * Retorna el maxim ID de literals de la taula Language_Text      * 
      * */
      private function getMaxIdLiteral() {
      	
      	try {
      	
      	$con = Propel::getConnection();   	
      
      	$sql = "SELECT max(IdLanguageLiteral) max FROM `language_literal`";
      	$stm = $con->createStatement();      	
      	//FETCHMODE_ASSOC =  Index result set by field name.
      	//FETCHMODE_NUM =   Index result set numerically.
      	$rs = $stm->executeQuery($sql,ResultSet::FETCHMODE_ASSOC);
     
      	//echo "<br/> CONTADOR:".$rs->getRecordCount();
      		
	      	while($rs->next()) {     	    
	      	    $max = $rs->getInt("max");
	      	}
      	
      	}
      	catch(Exception $ex) {
      		$ex->getMessage();
      		return false;      		
      	}
      	return $max;
      	
      }
      
      public function buscar()
      {
      	
      	$cat = $this->selectLiterals(self::CAT,$_POST['idLiteral1']);
      	$esp = $this->selectLiterals(self::ESP,$_POST['idLiteral1']);
      	$eng = $this->selectLiterals(self::ENG,$_POST['idLiteral1']);
      	 
      	$this->set('idLiteral',$_POST['idLiteral1']);
      	      	
      	$this->set('cat',$cat->getLiteral());
		$this->set('esp',$esp->getLiteral());
		$this->set('eng',$eng->getLiteral());
		 
		$this->set('button_action','modificar');       
      }
      
      public function __destruct()
      {
          parent::__destruct();
      }
      
      /*Guarda un literal de un idioma en la base de datos. */
      private function insertLanguage($idIdioma,$idLiteral,$literal)
      {
      	try {      		
      	    
      	    /*	
      			echo "<br/> idIdioma:".$idIdioma;
      			echo "<br/> idLiteral:".$idLiteral;
      			echo "<br/> literal:".$literal;
      		*/      		
	      	$language = new LanguageLiteral();	      	
	  		$language->setIdlanguageliteral($idLiteral);
	        $language->setIdlanguages($idIdioma);
	        $language->setLiteral($literal);
	        $language->save();
	        
	        unset($language);
	        
        return true;
      	}
      	catch (PropelException $ex){
      		
      		echo "<br/>".$ex->getCause();
      		return false;	
      	}
        
        unset($language);     		      	
      }
      
      private function saveFileInsertDB($idIdioma,$idLiteral,$literal) {
      	   	
      	$text = "INSERT INTO Language_Literal (IdLanguageLiteral, IdLanguages, Literal) VALUES($idLiteral,$idIdioma,'$literal');\n";      	   	
      	$handle = fopen('./modules/languages/literals.prop',"ab"); /* Esta en el mismo directorio el fichero de literales */
      	fwrite($handle,$text);      	
      	fclose($handle);    	      	 
      	
      }	  		
  		
      private function saveConstFile($idLiteral,$literal) {
      	
      	$text =  "		const LIT_".strtoupper($literal)." = '$idLiteral';\n";      	
      	$handle = fopen('./includes/Util/Literals.php',"ab"); /* Esta en el mismo directorio el fichero de literales */      	
      	fwrite($handle,$text);      	
      	fclose($handle);  
      	
      }
      
      private function saveScreenCode($idLiteral,$literal) {
      	
       
      	$text =  '$this->set("lit_'.strtolower($literal).'",$this->getLiteral(FR_Util_Literals::LIT_'.strtoupper($literal).'));'."\n";		
      	
      	$handle = fopen('./modules/languages/setPantallas.tmp',"ab"); /* Esta en el mismo directorio el fichero de literales */      	
      	fwrite($handle,$text);      	
      	fclose($handle);  
      	
      	
      }
      
      private function &selectLiterals($idIdioma,$idLiteral){
      	try {
      			
      	  		echo "<br/> idIdioma:".$idIdioma;
      			echo "<br/> idLiteral:".$idLiteral;      		
      			
      		$c = new Criteria(); 
      		$c->add(LanguageLiteralPeer::IDLANGUAGELITERAL,$idLiteral);
			$c->addAnd(LanguageLiteralPeer::IDLANGUAGES,$idIdioma);	
			
			$rs = LanguageLiteralPeer::doSelect($c);
			
			echo "CONTDO:".count($rs);
			echo "VISUALITZAR:".$rs[0]->getLiteral();
			
      		if( count($rs) > 0 ) return $rs[0];
      		else return false;				
      	 }
      	catch (PropelException $ex){
      		
      		echo "<br/>".$ex->getCause();
      		return false;	
      	}
      }
	
}
?>