<?php
/*
 *                        searchInObservation.php
 *                    ------------------
 * Creado            : 20-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */

require_once('toSearchObservation.php');
require_once('modules/observations/ObservationConst.php'); 

class searchInObservation extends FR_Auth_No {
	
	  
  
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
      	
      }
      
      /*
       * Campos de busqueda
       * 
       * 	1 = ObservationTitle
       *    2 = Place
       *    3 = People
       *    4 = Coment
       *    5 = Url
       *    6 = ObserDate        
       **/
       
           
 public function searchInObservation() { 
      	
      	try{
      		
      		$result = array();      			
      		$field = $_GET['field'];
      		$criteria = '%'.$_POST['textToFind'].'%'; 
      		     		
      		$c = new Criteria();		
      		$c->add(ObservationsPeer::USERID,$this->session->userID);  		
      		
      		/* Diferents campos de busqueda */
      		if(1 == $field) {
      			$c->addAnd(ObservationsPeer::OBSERVATIONTITLE,$criteria,Criteria::LIKE);      			
      		}
      		elseif(2 == $field)$c->addAnd(ObservationsPeer::PLACE,$criteria,Criteria::LIKE);
      		elseif(3 == $field)$c->addAnd(ObservationsPeer::PEOPLE,$criteria,Criteria::LIKE);
      		elseif(4 == $field)$c->addAnd(ObservationsPeer::COMENT,$criteria,Criteria::LIKE);
      		elseif(5 == $field)$c->addAnd(ObservationsPeer::URL,$criteria,Criteria::LIKE);
      		elseif(6 == $field)$c->addAnd(ObservationsPeer::OBSERVDATE,$criteria,Criteria::EQUAL);	
      												
			$rs = ObservationsPeer::doSelect($c);
					
			if($rs[0]!= null) {
									
				//$this->set('resultSearch',$rs);
				/*Busqueda de los elementos musicales */
				/*Show observation elements */				
				
				$result = $this->getAllObservationsElements($rs);				
     	
     			if($result) {     		
			     		
			     		//echo "ELEMENTS TROBATs:".$result[0]->getMusicElementType()->getElementdesc();
			     		//echo "que es".print_r($result);
			     		$this->set('resultSearch',$result);	
			     		
			     		$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
						$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));		
						$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
						$this->set("lit_music_elem",$this->getLiteral(FR_Util_Literals::LIT_MUSIC_ELEM));
						$this->set("lit_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));		 
						
						$this->set("lit_song",$this->getLiteral(FR_Util_Literals::LIT_SONG));
			   		 	$this->set("lit_artist",$this->getLiteral(FR_Util_Literals::LIT_ARTIST));
			   		 	$this->set("lit_album",$this->getLiteral(FR_Util_Literals::LIT_ALBUM));
			   		 	$this->set("lit_genere",$this->getLiteral(FR_Util_Literals::LIT_GENERE));						
						    		
			     		$this->set('js_file','mod_search.js');
			     		$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
     			}
     			else {
     				$this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));
     				echo "NO HI HA RESULTAT!!!!!!!!!";	
     			}				
				//$this->set("lit_observ_title",$this->getLiteral(ObservationConst::LIT_OBSERV_TITLE));     		
     			$this->set('js_file','mod_search.js');     							
			}
	        else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));	    	
	    	
	    	  	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');
	    	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
	    	$this->set("search_yes",$_POST['textToFind']);	    	    	
	    	//$this->tplFile="observationSearch.tpl";
			$this->tplFile="eventObservation.tpl";	    	     		
	    	
      	}catch(PropelException $ex){
     	
     		echo "Excepcion:".$ex->getMessage();
	    	$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());   
      		return false;
      	}     	
      	
      }
      
      /*
       * Devuelve todos los elementos musicales que estan en las observaciones encontradas.
       * 
       * */
      private function getAllObservationsElements($Observations) {
      	
      	try{
      		
      		//$resultElements = array();
      		$elements = false;
      		$result = array();
      		$resultElements = array();
      		foreach($Observations as $observ) {
      			
      			$result = $this->getObservationElements($observ->getIdobservation());
      			     		
      				if($result) {
     		
     					/* Fusionar resultado de vectores */  
     					//print_r($result);
     					//echo("<br>--------------------------<br><br>");
     					$resultElements=array_merge($resultElements,$result);
     					//echo("<br>RESULT ELEMENT--------------------------<br><br>");
     					//print_r($resultElements);
     					     					  					
      					$elements = true;     				
      				}     				        		
      		}
      	
      		if ($elements) return $resultElements;
      		else return false;      		
      	      		
      	}catch(PropelException $ex)
      	{
      		return false;	
      		
      	}      	
      }
          
      
      /*
       * Devuelve los elementos musicales que estan en la tabla user use play y
       * tienen associadas las observaciones $observations 
       * */
      private function getElementsWithObservation($observations){
      	
      	$searchObserv = new toSearchObservation();
      	$result = array();
      	
      	foreach($observations as $observation) {
      		
      		$aux_result = $searchObserv->getObservationElements($observation->getIdobservation());
      		if($aux_result) $result=array_merge($result,$aux_result);     		
      	}
      	
      	return $result;
      	
      	
      }
            
      private function getObservationElements($idObservation){
      	
      	try{
      		
      		$c = new Criteria();	  		
			$c -> add(UserUsePlayPeer::IDOBSERVATION,$idObservation);//, 
			$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); 
			
			$rs = UserUsePlayPeer::doSelect($c);
     
		      
		   if ($rs[0]!= null) { /* si hay elementos musicales associados a las emociones */
		    	
		    	return $this->getMusicElemFromUserUsePlay($rs);
		    	
		    }/* No se ha encontrado resultado */
		    else return false; 
			
      		
      	}
      	catch(PropelException $ex){
     	
	     	echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      	}
      	
      } 
      
       /* Coje los elementos que cumplen las condiciones de los metodos
       * 
       * searchWithCriteria
       * searchWithoutCriteria
       *  
       * */
      private function getMusicElemFromUserUsePlay($rs){
     	
     	try{
     			$musicElements = array();
		    	foreach($rs as $object){ 
			    	
			    	if($object->getIdmusicelementtype() == 1) 	{
			    		$result = FR_GetModelObjects::getObjectSong($object->getIdmusicelement());
			    		if($result instanceof Song) 
			    		{
			    			/*echo "type: ".$result->getMusicElementType();
			    			echo "Name:".$result->getSongname();
			    			*/
			    			$musicElements[]=$result;	
			    		}
			    					    			
			    	}			    	
			    	if($object->getIdmusicelementtype() == 2){
			    		$result = FR_GetModelObjects::getObjectArtist($object->getIdmusicelement());
			    	    
			    	    if($result instanceof Artist) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br> type: ".$result->getMusicElementType()->getElementdesc();			    			
			    			echo "Name:".$result->getArtistname();
			    			echo "Songs:".$result->countSongs();*/			    				
			    		}
			    	} 	
			    	if($object->getIdmusicelementtype() == 3){
			    		$result = FR_GetModelObjects::getObjectAlbum($object->getIdmusicelement());
			    	    if($result instanceof Album) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getAlbumname();
			    			echo "Songs:".$result->countSongs();
			    			*/			    				
			    		}
			    		
			    	} 				    	
			    	if($object->getIdmusicelementtype() == 4) 	{
			    		$result = FR_GetModelObjects::getObjectGenere($object->getIdmusicelement());
			    		if($result instanceof Genere) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getGenerename();
			    			echo "Songs:".$result->countSongs();*/
			    				
			    		}
			    			
			    	}
			    	if($object->getIdmusicelementtype() == 5) {
			    		$result = FR_GetModelObjects::getObjectPlayList($object->getIdmusicelement());	
			    	}
		    	}
		    	return $musicElements;
		}
      	catch(PropelException $ex){     		     	       
      		return false;
      	}     
      	
      }	     
      
      /* 3 columna*/ 
  private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>