<?php

  /**
  * FR_Multimedia
  *
  * Multimedia class factoria. Es utilizada por el modulo analyze clase directorios.
  *   
  * @author J.EmilioNavarro <jemilionr@yahoo.es>
  * @package Framework
  * @see FR_Module::$presenter, FR_Presenter_common
  */

class FR_Multimedia {

	public static function factory($arr_tags,$info) {
			
		 /*Escojer el tipo de informacion que tenemos para recojer */          	
        $type_tag =  FR_Multimedia::choseTypeTag($arr_tags);	           
            
        $class = 'FR_Multimedia_Tag';          
         if (class_exists($class)) {        	            
                      
                $multimedia = new $class($info,$type_tag);                 
                  
                    if ($multimedia instanceof FR_Multimedia_InfoFile) {
                      return $multimedia;
                  }
                  return PEAR::raiseError('No se ha podido crear el objeto InfoFile: '.$class);                 
              }
              return PEAR::raiseError('No se encuentra la classe mutlimedia: '.$class);      
       	}
	
    private static function choseTypeTag($arr_tags) {
			
		if (array_key_exists('id3v2',$arr_tags)) { return 'id3v2'; }
		elseif (array_key_exists('id3v1',$arr_tags)) return $arr_tags['id3v1'];
		else return false;	
	}
}



?>