<?php
/*
 *                      musicElement.php
 *                    ------------------
 * Creat            : 13-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 
class FR_Pagination_MusicElement extends FR_Pagination {
	
      public function __construct($class,$module,$actionClass,$cri=null)
      {
          parent::__construct($class,$module,$actionClass,$cri);          
      }		
	
public function getUrlActions($musicElement) {

		/* 
		 * URL para hacer el streaming PLAY: ALL | RANDOM 
		 * Tantos como elementos se hayan obtenido del resultado en la base de datos 
		 */	
			
		$playAll = array();
		$playRandom = array();
		 
		$action = "getId".$musicElement;
		
		/*
			echo "<br/> Action: ".$action;
			echo "<br/> Numero elementos:".$this->num_pages;
			echo "<br/> Elementos por pagina: ".$this->max_elem_page;
		*/
		
		for($i=0;$i < $this->max_elem_page;$i++){
			
			$element = $this->objects[$i];				
			$playAll[$i] = $this->play($musicElement,$element->$action());
			$playRandom[$i] = $this->play('playRandom',$element->$action());			
		}	

	$this->result['playAll'] = $playAll;
	$this->result['playRandom'] = $$playRandom;	
	
	unset($playAll);
	unset($playRandom);	
}

public function createPagination($musicElement,$cri=null)
{
	if($this->getPagesStructure($cri)){
		
		$this->getUrlActions($musicElement);
		return true;		
	}	
	else return false; /* No hay paginas para mostrar */
}


private function play($type_play,$id) {
	
 return WEB_PATH.'/index.php?module=streaming&class=sing&event='.$type_play.'&id='.$id;
 	
}

protected function initCriteria($cri)
{
		$colum = $this->baseClass.'Name';
		
		$c = new Criteria();	
		$c->addAscendingOrderByColumn($colum);
		
							/*Si s'ha definido un criterio mas especifico. Para la columna Name */
		if(isset($cri)) { 
			$col= $this->baseClass.'.'.$colum; /* Acceso a la columna de la base de datos. Ex.Album.AlbumName */
			$c->add($col,$cri,Criteria::LIKE);
		}
		
		$c->setLimit($this->limit);	
		$c->setOffset($_GET['offset']);
		
		return $c;
	
}


public function getPlayAll() {
	
	if (null != $this->result['playAll']) return $this->result['playAll'];
	else return false;
}

public function getPlayRandom() {
	
	if (null != $this->result['playRandom']) return $this->result['playRandom'];
	else return false;
}


	  public function __destruct()
      {
          parent::__destruct();         
      } 
} 
 
 
?>
