<?php

/*
 *                      AdminEmotions.php
 *                    ------------------
 * Creat            : 21-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 
include_once('EmotionConst.php');
 
class AdminEmotion extends FR_Auth_No {
 
 //const URL_BACK_PAGINATION = "index.php?module=observations&class=AdminObservation&event=getPagination";      
      
      public function __construct()
      {
           parent::__construct();          
      }      
      
      public function __default()
      {
           $this->getEmotions();
      }
      
public function screenNew() {
  
  	 /* 3 C O L U M N A */
	    $this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();  	 
  	 
  	 $this->screenLiterals(); 
  	 $this->set("lit_action",$this->getLiteral(FR_Util_Literals::LIT_NEW));
  	 $this->set("button_action",'newEmotion'); 
   	 $this->tplFile="admin_emotions.tpl";   
   	 	 	
   }
   
/* Introduce los literales necesarios para la pantalla  */

private function screenLiterals() {
   	
   	$this->set("lit_user_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));
   	$this->set("lit_icon",$this->getLiteral(EmotionConst::LIT_ICON));
	$this->set("lit_max_songs",$this->getLiteral(EmotionConst::LIT_MAX_SONGS));	
	$this->set("lit_find_in",$this->getLiteral(EmotionConst::LIT_FIND_IN));
	$this->set("lit_songs",$this->getLiteral(FR_Util_Literals::LIT_SONGS));
	$this->set("lit_albums",$this->getLiteral(FR_Util_Literals::LIT_ALBUMS));
	$this->set("lit_artists",$this->getLiteral(FR_Util_Literals::LIT_ARTISTS));	
	$this->set("lit_playlists",$this->getLiteral(FR_Util_Literals::LIT_PLAYLISTS));
	$this->set("lit_generes",$this->getLiteral(FR_Util_Literals::LIT_GENRES));	
	
	$this->set("lit_selection_criteria",$this->getLiteral(FR_Util_Literals::LIT_SELECTION_CRITERIA));
	$this->set("lit_without_criteria",$this->getLiteral(EmotionConst::LIT_WITHOUT_CRITERIA));
	$this->set("lit_my_observations",$this->getLiteral(FR_Util_Literals::LIT_MY_OBSERVATIONS));
	$this->set("lit_my_plays",$this->getLiteral(FR_Util_Literals::LIT_MY_PLAYS));
	
	$this->set("lit_the_songs",$this->getLiteral(EmotionConst::LIT_THE_SONGS));
	$this->set("lit_most_listened_song",$this->getLiteral(FR_Util_Literals::LIT_MOST_LISTENED_SONG));
	$this->set("lit_less_listened_song",$this->getLiteral(FR_Util_Literals::LIT_LESS_LISTENED_SONG));	
	
	$this->set("lit_punctuation",$this->getLiteral(FR_Util_Literals::LIT_PUNCTUATION));	
	
	$this->set("lit_between",$this->getLiteral(EmotionConst::LIT_BETWEEN));
	$this->set("lit_and",$this->getLiteral(EmotionConst::LIT_AND));
	$this->set("lit_between_day",$this->getLiteral(EmotionConst::LIT_BETWEEN_DAY));
	
	$this->set("lit_emotion",$this->getLiteral(EmotionConst::LIT_EMOTION));
  	$this->set("lit_new",$this->getLiteral(FR_Util_Literals::LIT_NEW));		/* Literal new */ 
	$this->set("lit_back",$this->getLiteral(FR_Util_Literals::LIT_BACK));
	
	
	/* SPECIFIC JAVA SCRIPT FILE */
    $this->set("js_file",'mod_emotions.js');	
}
   
public function getEmotions() {
  	
  	try{
  	
      $rs = $this->getUserEmotions();
	    
	    if (count($rs) > 0 ) {    	
			    
			    $this->set("emotions",$rs);
			    $this->setFindIn($rs); /* Donde se buscan las canciones, albums,artistas, ...*/ 	
			   	
	    }
	    else $this->set("message",$this->getLiteral(EmotionConst::LIT_NOT_EMOTIONS_YET));
	    
	    /* 3 C O L U M N A */
	    $this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();
		 			
  		
  		$this->set("lit_emotion",$this->getLiteral(EmotionConst::LIT_EMOTION));
  		$this->set("lit_new",$this->getLiteral(FR_Util_Literals::LIT_NEW));		/* Literal new */        
        $this->set("lit_back",$this->getLiteral(FR_Util_Literals::LIT_BACK));
        $this->set("lit_alter",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
        $this->set("lit_eliminar",$this->getLiteral(FR_Util_Literals::LIT_ELIMINAR));
        $this->set("lit_select",$this->getLiteral(EmotionConst::LIT_SELECT));
		$this->set("lit_songs_from",$this->getLiteral(EmotionConst::LIT_SONGS_FROM));
        $this->tplFile="emotions.tpl"; 
  		
  	}
  	catch(PropelException $ex){
     	
     	echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());   
      	return false;
     }  	
  }
  
  private function setFindIn($emotions) {
  	
  	$findIn = array();
  	foreach($emotions as $emotion) {
  		
  		$search = $emotion->getEmotionSearchs();  		
  		$result = split(',',$search[0]->getFindin()); //Separa la cadena separada por comas (,)
  		$findIn[]=$result; //Alamcenamos el vector resultante en el array que es enviado a la pantalla
  	}
  	  	
  	/*Pasamos a la pantalla los datos obtenidos del hacer el split */
  	$this->set("findIn",$findIn);  	
  } 
  
 public function newEmotion () {
   	
   	/*
   	 * Tipos de criterios de busqueda de emociones ( name=emot_Criteria )
   	 * 
   	 * 1 = Sin criterios
   	 * 2 = Mis observaciones
   	 * 3 = Mis reproducciones 
   	 * */
	
	try{
		
		$emotion = new Emotions();
				
		$emotion_search = new EmotionSearch();
		
		/* EMOTION */
		
		$emotion->setUrlicon("web/img/Smiley.png");
		$emotion->setEmotionname($_POST['emot_name']);
		$emotion->setUserid($this->session->userID);		
		
		/* EMOTION SEARCH */
		
		$emotion_search->setUserid($this->session->userID);
		if($_POST['emot_max_songs']== null){
			$emotion_search->setMaxsongs(0);
		}
		else $emotion_search->setMaxsongs($_POST['emot_max_songs']);			 		
		 /*
		  * emot_Criteria
		  * 
		  *	 Findin son los albums, generos, artistas, canciones y playlist	donde se bucaran las canciones
		  *  a recomendar.
		  */	
		  
		$findIn = ""; 
				   	
		/*Buscar las canciones en */
		if(null != $_POST['emot_songs']) { 
			
			$findIn.="1,";
		}
		
		if(null != $_POST['emot_artists']) { 
			
			$findIn.="2,";
		}		
		if(null != $_POST['emot_albums']) { 
			
			$findIn.="3,";
		}
		if(null != $_POST['emot_genere']) { 
			
			$findIn.="4,";
		}			
		if(null != $_POST['emot_playlist']) { 
			
			$findIn.="5,";
		}
		
		$findIn = substr($findIn,0,(strlen($findIn)-1));	
		$emotion_search->setFindin($findIn);
		
		
		/* OBSERVACIONES!!! PASARE DE ELLAS 
		 *  
		 * emot_songs_play	
		 * if(null != $_POST['emot_songs_play]'])$emotion_search->setTypefind($_POST['emot_songs_play]']);
		 * 2--> TENEMOS OBSERVACIONES para hacer la busqueda
		 * $emotion_observation = new EmotionsHasObservations();
		 * $emotion_observation->addEmotionsHasObservations();
		 * $emotion_observation->setIdobservation($_POST['']);
		 * */
		
		/* Criterio de busqueda: USO DE LA MUSICA, REPRODUCCIONES */
		
		if(3 == $_POST['emot_Criteria']) {
		
		    /*
			 * emot_songs_play			  
			 * 1 --> most_listened_song
			 * 0 --> less_listened_song	 				 		  		 
			 * */
			 		 
		 	if(null != $_POST['emot_songs_play'])$emotion_search->setTypefind($_POST['emot_songs_play]']);			
			
			//Solo un valor o los dos si es intervalo
			if(0 != $_POST['emot_punctuation']) $emotion_search->setPointini($_POST['emot_punctuation']);
			
			//Segundo valor del intervalo de puntuacion
			if(0 != $_POST['emot_punctuation_3']) $emotion_search->setPointfi($_POST['emot_punctuation_3']);		
			
			/* TRATAMIENTO DE FECHAS */
			
			//Intervalo de fechas. Si una esta inicializada la otra tambien, por JavaScript esta controlado
			if(null != $_POST['emot_init_day']) { 
					
				/* VALIDACION IDIOMA */
				if( 1 == $this->session->idioma || 2 == $this->session->idioma) {  /* CATALAN Y ESPAOL */
						
						if(FR_Util_Miscelanea::checkLatinDate($_POST['emot_init_day'])) {
							
						   $init_day = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['emot_init_day']);						 																		
						}
						else $messages[] = 'Invalid date: '.$_POST['emot_init_day'];
						
					   if(FR_Util_Miscelanea::checkLatinDate($_POST['emot_end_day'])) {
							
							$end_day = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['emot_end_day']);																			
						}
						else $messages[] = 'Invalid date: '.$_POST['emot_end_day'];
														
				}
				else {  /*E N G L I S H   D A T E */
					
					if(FR_Util_Miscelanea::checkEnglishDate($_POST['emot_init_day'])) {
						$init_day = $_POST['emot_init_day'];						
					}
					else $messages[] = 'Invalid date: '.$_POST['emot_init_day'];
					
					if(FR_Util_Miscelanea::checkEnglishDate($_POST['emot_end_day'])) {
						
						$end_day = $_POST['emot_end_day'];
					}
					else $messages[] = 'Invalid date: '.$_POST['emot_end_day'];	
					
				} // Fin English Date		
				
				if(null != $messages[0]) { /* Si hay errores tienen que volver a entrar las fechas */
							
					$this->setValuesToScreen();
					$this->set("messages",$messages);				
					/* Proceso de alta */
					$this->set("lit_action",$this->getLiteral(FR_Util_Literals::LIT_NEW));		
					$this->set("button_action",'newEmotion');			 
				  	return false;							
				}
				else { /* No hay errores, continuan con el proceso de alta. */
					
					$emotion_search->setInitdate($init_day);
					$emotion_search->setFindate($end_day);
				}		

			}				
		}		
		
		$emotion->addEmotionSearch($emotion_search);	
		$emotion->save();
		
		/*Todo correcto volvmos pagina principal*/
		$this->set("info_message",$this->getLiteral(EmotionConst::LIT_CORRECT_EMOTION));
		$this->__default();	
			
	}   
	catch(PropelException $ex){
     	
     	echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());   
      	return false;
     }
   	
 	
   	
   }
   
   /* 
    * Passa a la pantalla los valores de una emocion que se esta creando y tiene error de
    * fechas y hemos entrado y tenemos que volver a salir 
    * 
    * */
   private function setValuesToScreen() {
   	
   	 $this->screenLiterals();
   	
   	 if(null != $_POST['emot_name']) $this->set("emot_name",$_POST['emot_name']);
   	 if(null != $_POST['url_icon']) $this->set("url_icon",$_POST['url_icon']);
   	 if(null != $_POST['emot_max_songs']) $this->set("emot_max_songs",$_POST['emot_max_songs']);

	if(null != $_POST['emot_songs']) $this->set("emot_songs",$_POST['emot_songs']);  		
	if(null != $_POST['emot_albums']) $this->set("emot_albums",$_POST['emot_albums']); 		
	if(null != $_POST['emot_artists']) $this->set("emot_artists",$_POST['emot_artists']); 			
	if(null != $_POST['emot_playlist'])  $this->set("emot_playlist",$_POST['emot_playlist']); 		
	if(null != $_POST['emot_genere'])  $this->set("emot_genere",$_POST['emot_genere']); 

	 
	if(null != $_POST['emot_songs_play']) $this->set("emot_songs_play",$_POST['emot_songs_play']); 
	
	/* Criteri de puntuacio per les cerques */
	
	if(0 != $_POST['emot_punctuation_3']) { /* I N T E R V A L O */
		
	  	/* I N I C I A L */
	  	for($i=1;$i<=$_POST['emot_punctuation'];$i++) {
			
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_B_".$i,$punt_src);			
		}	
		
		/* F I N A L */
		$this->set("emot_punctuation_3",$_POST['emot_punctuation_3']);
		for($i=1;$i<=$_POST['emot_punctuation_3'];$i++) {
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_C_".$i,$punt_src);			
		}	
	} 
	else if(0 != $_POST['emot_punctuation'])  { /* F I J A */
		
	    /* P U N T U A C I O N    F I J A */
	  	for($i=1;$i<=$_POST['emot_punctuation'];$i++) {
			
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_A_".$i,$punt_src);			
		}		
		$this->set("emot_punctuation",$_POST['emot_punctuation']);		
	} 
		
			
	if(null != $_POST['emot_init_day']){
		
		$this->set("emot_init_day",$_POST['emot_init_day']);
	}  
	if(null != $_POST['emot_end_day']) $this->set("emot_end_day",$_POST['emot_end_day']); 		   	    	 
   	
   	$this->tplFile="admin_emotions.tpl";
   	   	
   }
   
   
   /*
    * Pasa a la pantalla los valores de una EMOCION que ja existia para poder ser modificada.
    * 
    * */
   
   public function screenAlterEmotion() {
   	
   	try {
   		
     $emotion = EmotionsPeer::retrieveByPK($_GET['idEmotion']);
   		
   	$e_searchs = $emotion->getEmotionSearchs();
   	$emotion_search =  $e_searchs[0];
   				
	if (null != $emotion_search) { /*Tenim emocio ham cerca */	   	
   	
   	    
   	    $this->set("emot_id",$emotion->getIdemotion());
   	    $this->set("emot_name",$emotion->getEmotionname());   		 
 		$this->set("url_icon",$emotion->getUrlicon());
 		 		
 		if($emotion_search->getMaxsongs() > 0) $this->set("emot_max_songs",$emotion_search->getMaxsongs());

		$result = split(',',$emotion_search->getFindin()); //Separa la cadena separada por comas (,)
	
		if(null != $result[0]) $this->set("emot_songs",$this->getLiteral(FR_Util_Literals::LIT_SONGS));  		
		if(null != $result[1]) $this->set("emot_artists",$this->getLiteral(FR_Util_Literals::LIT_ARTISTS)); 		
		if(null != $result[2]) $this->set("emot_albums",$this->getLiteral(FR_Util_Literals::LIT_ALBUMS));		
		if(null != $result[3]) $this->set("emot_genere",$this->getLiteral(FR_Util_Literals::LIT_GENERE)); 		
		if(null != $result[4]) $this->set("emot_playlist",$this->getLiteral(FR_Util_Literals::LIT_PLAYLISTS)); 
 
	 
	if(null != $emotion_search->getTypefind()) $this->set("emot_songs_play",$emotion_search->getTypefind()); 
	
	/* Criteri de puntuacio per les cerques */
	
	if(0 != $emotion_search->getPointfi()) { /* I N T E R V A L O  DE  P U N T U A C I O N */
		
	  	/* I N I C I A L */
	  	$this->set("emot_punctuation",$emotion_search->getPointini());
	  	for($i=1;$i<=$emotion_search->getPointini();$i++) {
			
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_B_".$i,$punt_src);			
		}	
			
		
		/* F I N A L */
		$this->set("emot_punctuation_3",$emotion_search->getPointfi());
		for($i=1;$i<=$emotion_search->getPointfi();$i++) {
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_C_".$i,$punt_src);			
		}	
		
	} 
	else if(0 != $emotion_search->getPointini())  { /* F I J A */
		
	    /* P U N T U A C I O N    F I J A */
	  	for($i=1;$i<=$emotion_search->getPointini();$i++) {
			
			$punt_src='web/img/P'.$i.'.PNG';
			$this->set("punt_src_A_".$i,$punt_src);			
		}		
		$this->set("emot_punctuation",$emotion_search->getPointini());		
	} 
		
			
		if(null != $emotion_search->getInitdate(FR_Util_Miscelanea::getFormaDate(1))) $this->set("emot_init_day",$emotion_search->getInitdate(FR_Util_Miscelanea::getFormaDate(1))); 
		if(null != $emotion_search->getFindate(FR_Util_Miscelanea::getFormaDate(1))) $this->set("emot_end_day",$emotion_search->getFindate(FR_Util_Miscelanea::getFormaDate(1)));
   	
   		
	}
	else { /* No s'han trobat les emocion_search d'una cerca. */
		
		$this->getEmotions();
		$this->set("message","NO SE HA PODIDO ENCONTRAR LA CERCA ASSOCIADA A LA EMOCION");
	}  
   		
   		
   		
   		
  	 $this->screenLiterals(); 
  	 /* 3 C O L U M N A */
	    $this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();
    $this->set("lit_back",$this->getLiteral(FR_Util_Literals::LIT_BACK));
  	 $this->set("lit_action",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
  	 $this->set("button_action",'alterEmotion'); 
   	 $this->tplFile="admin_emotions.tpl";
   	 unset($emotion); 
   	}
   	catch(PropelException $ex){
     	
     	echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($emotion); 
	       
      	return false;
     }
   	
 }  	   
   
   
   public function alterEmotion() {
   	
   	try{
   	 		   	
   		   $emotion = EmotionsPeer::retrieveByPK($_POST['emot_id']);  		
   		   $e_searchs = $emotion->getEmotionSearchs();
   		   $emotion_search = $e_searchs[0];
   		   
   		   if(null != $_POST['emot_name']) $emotion->setEmotionname($_POST['emot_name']);
   	 	   if(null != $_POST['url_icon']) $emotion->setUrlicon($_POST['url_icon']);
   	       if(null == $_POST['emot_max_songs']) $emotion_search->setMaxsongs(0);
   	       else $emotion_search->setMaxsongs($_POST['emot_max_songs']);

		 /*
		  * emot_Criteria
		  * 
		  *	 Findin son los albums, generos, artistas, canciones y playlist	donde se bucaran las canciones
		  *  a recomendar.
		  */	
		  
		$findIn = ""; 
				   	
		/*Buscar las canciones en */
		if(null != $_POST['emot_songs']) { 
			
			$findIn.="1,";
		}
		
		if(null != $_POST['emot_artists']) { 
			
			$findIn.="2,";
		}		
		if(null != $_POST['emot_albums']) { 
			
			$findIn.="3,";
		}
		if(null != $_POST['emot_genere']) { 
			
			$findIn.="4,";
		}			
		if(null != $_POST['emot_playlist']) { 
			
			$findIn.="5,";
		}
		
		$findIn = substr($findIn,0,(strlen($findIn)-1));	
		$emotion_search->setFindin($findIn); 

		//print_r($_POST);	
	 
			if(3 == $_POST['emot_Criteria']) {
			
		    /*
			 * emot_songs_play			  
			 * 1 --> most_listened_song
			 * 0 --> less_listened_song	 				 		  		 
			 * */
			 		 
		 	if(null != $_POST['emot_songs_play'])$emotion_search->setTypefind($_POST['emot_songs_play]']);			
			
			//PUNTUACION FIJA!!!
			if(0 != $_POST['emot_punctuation'] && 0 == $_POST['emot_punctuation_3']){
				
				$emotion_search->setPointini($_POST['emot_punctuation']);
				$emotion_search->setPointfi(0);			
			}//HAY UN INTERVALO DE PUNTUACION
			elseif(0 != $_POST['emot_punctuation_3']) {
				
				$emotion_search->setPointini($_POST['emot_punctuation']);
				$emotion_search->setPointfi($_POST['emot_punctuation_3']);	
			}
			else{ /*No hay puntuacion inicializamos a zero*/
				
				/* Puntuacion */
				$emotion_search->setPointini(null);
				$emotion_search->setPointfi(null);
				
			}	
			
			/* TRATAMIENTO DE FECHAS */			
			//Intervalo de fechas. Si una esta inicializada la otra tambien, por JavaScript esta controlado
			if(null != $_POST['play_song_3']) { 
				
				
				
					/* VALIDACION IDIOMA */
					if( 1 == $this->session->idioma || 2 == $this->session->idioma) {  /* CATALAN Y ESPAOL */
							
						
							if(FR_Util_Miscelanea::checkLatinDate($_POST['emot_init_day'])) {
								
							   $init_day = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['emot_init_day']);						 																		
							}
							else $messages[] = 'Invalid date: '.$_POST['emot_init_day'];
																					
						   if(FR_Util_Miscelanea::checkLatinDate($_POST['emot_end_day'])) {
								
								$end_day = FR_Util_Miscelanea::transformLatinDateToDataBaseFormat($_POST['emot_end_day']);																			
							}
							else $messages[] = 'Invalid date: '.$_POST['emot_end_day'];
							
															
					}
					else {  /*E N G L I S H   D A T E */
						
						if(FR_Util_Miscelanea::checkEnglishDate($_POST['emot_init_day'])) {
							$init_day = $_POST['emot_init_day'];						
						}
						else $messages[] = 'Invalid date: '.$_POST['emot_init_day'];
						
						if(FR_Util_Miscelanea::checkEnglishDate($_POST['emot_end_day'])) {
							
							$end_day = $_POST['emot_end_day'];
						}
						else $messages[] = 'Invalid date: '.$_POST['emot_end_day'];	
						
					} // Fin English Date		
					
					if(null != $messages[0]) { /* Si hay errores tienen que volver a entrar las fechas */
								
						$this->setValuesToScreen();
						$this->set("messages",$messages);
						$this->set("emot_id",$_POST['emot_id']);			
						/* Proceso de alta */  	 			
	  	 				$this->set("lit_action",$this->getLiteral(FR_Util_Literals::LIT_ACTION_MODIFCAR));
	  	 				$this->set("button_action",'alterEmotion'); 			 
					  	return false;							
					}
					else { /* No hay errores, continuan con el proceso de alta. */
						
						$emotion_search->setInitdate($init_day);
						$emotion_search->setFindate($end_day);
					}	
			}//Fin de if de fechas
			else { /* Las ponemos a zero */
				
					$emotion_search->setInitdate(null);
					$emotion_search->setFindate(null);						
			}	
		} //Fin de if emotion con criterio		  
		else { /* Las ponemos a zero */
				
					/* Fechas */
					$emotion_search->setInitdate(null);
					$emotion_search->setFindate(null);
					
					/* Puntuacion */
					$emotion_search->setPointini(null);
					$emotion_search->setPointfi(null);		
			}
		
	  	$emotion->addEmotionSearch($emotion_search);	
		$emotion->save();
		
		/*Todo correcto volvmos pagina principal*/
		$this->set("info_message",$this->getLiteral(EmotionConst::LIT_CORREC_ALTER_EMOTION));
		$this->set("lit_correc_alter_emotion",$this->getLiteral(EmotionConst::LIT_CORREC_ALTER_EMOTION));
		$this->__default();		
				     	
   		}
   	   	catch(PropelException $ex){
     	
     	echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($emotion); 
	       
      	return false;
     }
   }
   
   public function deleteEmotion() {
   	
   	 try {
     		
     		
     		$emotion = EmotionsPeer::retrieveByPK($_GET['idEmotion']);  		
     		
     		/* D E L E T E los criterios de busqueda de   E M O T I O N __ S E A R C H*/
     		
     		$c = new Criteria();	    		
			$c -> add(EmotionSearchPeer::IDEMOTION,$_GET['idEmotion']);//, 
			$c -> addAnd(EmotionSearchPeer::USERID,$this->session->userID);
			$rs = EmotionSearchPeer::doSelect($c);
			
		    if (count($rs) > 0 ) { 
			    	
			    	foreach($rs as $object) {
			    		
			    		$object->delete();			    		
			    	}
			    	
			    }
			
     		 
     		/* D E L E T E las observaciones de I D__U S E R __U S E P L A Y*/
     		
     		$c = new Criteria();	    		
			$c -> add(UserUsePlayPeer::IDEMOTION,$_GET['idEmotion']);//, 
			$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID);     /* Usuario ficticio de la aplicacion 1 */
	
    		$rs = UserUsePlayPeer::doSelect($c);
        
			    if (count($rs) > 0 ) { 
			    	
			    	foreach($rs as $object) {
			    		
			    		$object->setIdemotion(null);
			    		$object->save();			    		
			    	}
			    	
			    }     		 
     		 $emotion->delete();  /*D E L E T E     E M O T I O N*/       		 	 
     		 unset($emotion);
     		 unset($object);
     		 unset($rs);     		   	

     		$this->set("info_message",$this->getLiteral(EmotionConst::LIT_DELETED_EMOTION));
     					
		    $this->getEmotions();
     		 
     	  }catch(PropelException $ex) {      	
	      	
		      	echo "ERROR".$ex->getCause();
		      	$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
		      	unset($emotion);
      		return false;
      	}       	
   	   	
   	   	
   	
   }
   

  
   /*devuelve las emociones definidas por un usuario*/
   public function getUserEmotions () {
	   	
	   	try{	   	  
	   	  $c = new Criteria();
	  	  $c -> add(EmotionsPeer::USERID,$this->session->userID);
	  	  $c -> addAscendingOrderByColumn(BaseEmotionsPeer::EMOTIONNAME);
			
		   /* Usuario ficticio de la aplicacion 1 */
			$rs = EmotionsPeer::doSelect($c);	
			return $rs;
	   	}
	   	catch (PropelException $ex) {
	   		
	   		throw PropelException($ex);	   		
	   	}
   	     	
   } 
  
  /* 3 columna*/ 
  private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
   
   
  

  	  public function __destruct()
      {
          parent::__destruct();
      }   
      
      
}     
 
 
 
?>
