<?php

/*
 *                      estadisticas.php
 *                    ------------------
 * Creat            : 09-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */

require_once('modules/emotions/AdminEmotion.php'); 
require_once('modules/stadistics/Stadistics.php');
require_once('ConstHome.php');
class home  extends FR_Auth_No {
 	
 
  function __construct() {
         
         parent::__construct();
  }
   public function __default() {
    	
    	$this->session->urlBack = $this->getUrlFrom();    	
    	$this->getStadistics();
    	
    	/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	$this->getTodayEvents();
    	
    	/* Literales */
    	$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
    	$this->set("lit_most_play_songs",$this->getLiteral(ConstHome::LIT_MOST_PLAY_SONGS));
		$this->set("lit_my_most_play_songs",$this->getLiteral(ConstHome::LIT_MY_MOST_PLAY_SONGS));
		$this->set("lit_most_punct_songs",$this->getLiteral(ConstHome::LIT_MOST_PUNCT_SONGS));
		$this->set("lit_most_punct_artists",$this->getLiteral(ConstHome::LIT_MOST_PUNCT_ARTISTS));
		$this->set("lit_new_album",$this->getLiteral(ConstHome::LIT_NEW_ALBUM));
    	
    	$this->tplFile="home.tpl";
   }
   
   public function getStadistics() {
   	
   		$stadistics = new Stadistics();
   		
   		/* Las canciones mas escuhadas APLICACION*/
   		$result=$stadistics->getListenedSongs(0,FR_Util_Const::ID_APPLICATION); /*Las canciones mas escuhadas por la aplicacion */
   		if($result) $this->set('MostListenedSongsApplicat',$result);
   		
   		/* Las canciones mas escuhadas usuario */
   		$result=$stadistics->getListenedSongs(0,$this->session->userID);
   		if($result) $this->set('MostListenedSongsUser',$result);
   		
   		/* Selecciona las CANCIONES que han tenido mas puntuacion de la aplicacion */
   		$result=$stadistics->getMaxSongPuntuation(FR_Util_Const::ID_APPLICATION);
   		if($result) $this->set('MaxSongPuntuation',$result);
   		
   		/* Selecciona las ARTIST que han tenido mas puntuacion de la aplicacion */
   		$result=$stadistics->getMaxArtistPuntuation(FR_Util_Const::ID_APPLICATION);
   		if($result) $this->set('MaxArtistPuntuation',$result);
   		
   		/* Selecciona los NUEVOS ALBUMS DADOS DE ALTA */
   		$result=$stadistics->getNewAlbum();   		 	
   		if($result) $this->set('NewAlbums',$result); 
   		
   		unset($result);		
   	
   }
   
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result) {
   			$this->set('userEmotions',$result);
   		}    		
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
    
   public function  getUrlFrom() {
   	
   	 return "index.php?module=home&class=home";
   	
   }
    
   public function __destruct()
   {
          parent::__destruct();
   } 
  
}
?>
