<?php
/*
 *                        AdminSOAP.php
 *                    ------------------
 * Creado            : 31-ago-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
include_once("includes/SOAP/nusoap.php");

 class AdminSOAP extends FR_Auth_No {
	
	    
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
      	
      }
      
      public function searchInfo(){
      	
      	try{
			
			if(isset($_GET['key'])) {				
				
				$key = $_GET['key'];				
				$key = str_replace(" ","%20",$key);
				
				$idioma = FR_Util_Miscelanea::getGoogleIdiom($this->session->idioma);
				
												
				$soapclient = new soapclient("http://api.google.com/search/beta2");
				
				// uncomment the next line to see debug messages
				// $soapclient->debug_flag = 1;
				// set up an array containing input parameters to be
				// passed to the remote procedure
				
				$params = array(
				'key' => '1kRWC3BQFHK6EDf6zIK4VtgGC/Xqi+cJ',   // Google license key
				'q'   => $key,                            	   // search term
				'start' => 0,                                  // start from result n
				'maxResults' => 10,                            // show a total of n results
				'filter' => false,                             // remove similar results
				'restrict' => 'countryES',                              // restrict by topic
				'safeSearch' => false,                         // remove adult links
				'lr' => $idioma, 	                               // restrict by language
				'ie' => '',                                    // input encoding
				'oe' => ''                                     // output encoding
				);
				// invoke the method on the server
				$result = $soapclient->call("doGoogleSearch", $params,"urn:GoogleSearch", "urn:GoogleSearch");
				//echo "<br>DINTRE BUSQUEDA";
				//echo "<br>contador:".count($result)." ".$result;											
				//print_r($result["resultElements"]);												
				$this->set('resultSearch',$result["resultElements"]);								
			}
			else $this->set('not_elements','PARAMETROS INCORRECTOS');
			
			$this->screenLiterals();
			$this->tplFile="googleResult.tpl";
			
      	}
      	catch(Exception $ex) {
      		echo "EXCEPCION PROBLEMA-----";
      		$this->tplFile="googleResult.tpl";
      		
      	}      	
      }
      
      
      
      public function screenLiterals(){
      	
      	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
      	/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    	//$this->set('3_User_Info_colum','si');
    	
    	/*Eventos de la agenda*/
    	//$this->getTodayEvents();
      	
      }
       public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
   
   /* Informacin 3 columna */
     
   private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
      
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>