<?php
/*
 *                      viewObservation.php
 *                    ------------------
 * Creat            : 19-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 
 
 include_once('ObservationConst.php');
 
class ViewObservation  extends FR_Auth_No { 	
 
  function __construct() {
         
         parent::__construct();
  }

   public function __default()
   {
    	//$this->session->urlBack = $this->getUrlFrom();
    	$this->generatePopUp();
    	//observation->getIdobservation();
    	
    	
   }
   
   private function generatePopUp() {  	
   	
  
		$this->set("lit_popUp",$_GET['idObservation']);
		
	try {	
	      		      	          		        
	        $observation = ObservationsPeer::retrieveByPK($_GET['idObservation']);
	      	      		
	        $this->set("observ_title",$observation->getObservationtitle());
	        $this->set("id_observ",$observation->getIdobservation());
	        $this->set("observ_place",$observation->getPlace());
	        $this->set("observ_people",$observation->getPeople());
	        $this->set("observ_comment",$observation->getComent());
	        $this->set("observ_url",$observation->getUrl());
	        $this->set("observ_date",$observation->getObserdate(FR_Util_Miscelanea::getFormaDate($this->session->idioma)));
	        
	          if(null != $observation->getImage())  {
	        	$image = MULTIMEDIA_UPLOADS.$this->session->userID.'/'.$observation->getImage();
	        	$this->set("observ_image",$image);	
	        }
	        
     
	        
	        
	    /* LITERALES */
	        
	    $this->set("lit_place",$this->getLiteral(ObservationConst::LIT_OBSERV_PLACE));
		$this->set("lit_people",$this->getLiteral(ObservationConst::LIT_OBSERV_PEOPLE));
		$this->set("lit_url_observ",$this->getLiteral(ObservationConst::LIT_OBSERV_URL));
		$this->set("lit_obser_date",$this->getLiteral(FR_Util_Literals::LIT_DATE));
		$this->set("lit_observ_time",$this->getLiteral(ObservationConst::LIT_OBSERV_TIME));
		$this->set("lit_observ_comment",$this->getLiteral(ObservationConst::LIT_OBSERV_COMMENT));
		$this->set("lit_observ_multimedia",$this->getLiteral(ObservationConst::LIT_OBSERV_MULTIMEDIA));
		$this->set("lit_close",$this->getLiteral(FR_Util_Literals::LIT_CLOSE));
	     
	    unset($observation);
	    	
	    $this->pageTemplateFile="popUp.tpl";
   		$this->tplFile="load_pop_up.tpl";  
	           
	}
	catch(PropelException $ex) {      	
	      		echo "ERROR".$ex->getCause();
	      		$this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	      		unset($observation);
      		return false;
	}	
		
		
   		
   }
   
   public function __destruct()
   {
          parent::__destruct();
   }
 
}


?>
