<?php
/*
 *                        searchElement.php
 *                    ------------------
 * Creado            : 20-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
require_once('modules/playlist/AdminPlayList.php'); 
class searchElement extends FR_Auth_No {	
	  
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
      	
      }
      
      public function searchInAlbum() {
      	
      	try{
      	    
      	    $result = array();      	   		
      		$criteria = '%'.$_POST['textToFind'].'%';     		      		      		
      		$c = new Criteria();   		
      		
      		/* Diferentes campos de busqueda */
      		$c->add(AlbumPeer::ALBUMNAME,$criteria,Criteria::LIKE);
      		
      		$rs = AlbumPeer::doSelect($c);
					
			if($rs[0]!= null) {
				
				$this->set('resultSearch',$rs);     			
     			$this->set('js_file','mod_search.js');
     			$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
     			$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
     			$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
     			$this->set("lit_album",$this->getLiteral(FR_Util_Literals::LIT_ALBUM));
     			$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));	     					
			}
	    	else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));
	    	
	    	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');    
    			    	
	    	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
	    	$this->tplFile="searchAlbum.tpl";     		      		
      }
      catch(PropelException $ex){     	
	     	//echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      }
      	
      }//fin search album
      
      public function searchInArtist() {    	
      	
      		try{
      	    
      	    $result = array();      	   		
      		$criteria = '%'.$_POST['textToFind'].'%';
      		
      		      		      		
      		$c = new Criteria();   		
      		
      		/* Diferentes campos de busqueda */
      		$c->add(ArtistPeer::ARTISTNAME,$criteria,Criteria::LIKE);
      		
      		$rs = ArtistPeer::doSelect($c);
					
			if($rs[0]!= null) {
				
				$this->set('resultSearch',$rs);     			
     			$this->set('js_file','mod_search.js');
     			$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));	
     			$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
     			$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
     			$this->set("lit_artist",$this->getLiteral(FR_Util_Literals::LIT_ARTIST));
     			$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));				
			}
	    	else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));
	    	
	    	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');
    		    	    	
	    	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
	    	$this->tplFile="searchArtist.tpl";     		      		
      }
      catch(PropelException $ex){     	
	     	echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      }
      	
      }//fin search artist   	
      
      
      public function searchInGenere() {      	
      	
      try{
      	    
      	    $result = array();      	   		
      		$criteria = '%'.$_POST['textToFind'].'%';     		
      		      		      		
      		$c = new Criteria();   		
      		
      		/* Diferentes campos de busqueda */
      		$c->add(GenerePeer::GENERENAME,$criteria,Criteria::LIKE);
      		
      		$rs = GenerePeer::doSelect($c);
					
			if($rs[0]!= null) {
				
				$this->set('resultSearch',$rs);     			
     			$this->set('js_file','mod_search.js');
     			$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
     			$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
     			$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
     			$this->set("lit_genere",$this->getLiteral(FR_Util_Literals::LIT_GENERE));
     			$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));	 				
			}
		
	    	else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));
	    	
	    	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');    
	    		    	
	    	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
	    	$this->tplFile="searchGenere.tpl";     		      		
      }
      catch(PropelException $ex){     	
	     	//echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      }
      	
      }//fin search genere     
      
      public function searchInSong() {      	
      	
      	 try{
      	    
      	    $result = array();      	   		
      		$criteria = '%'.$_REQUEST['textToFind'].'%';     		
      		      		      		
      		$c = new Criteria();      		
      		/* Diferentes campos de busqueda */
      		$c->add(SongPeer::SONGNAME,$criteria,Criteria::LIKE);      		
      		$rs = SongPeer::doSelect($c);
					
			if($rs[0]!= null) {
				
				$this->set('resultSearch',$rs);     			
     			$this->set('js_file','mod_search.js');
     			$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
     			
     			/* User PlayList */
				/* User PlayList */
				$userPlayList = AdminPlayList::getAllUserPlayList($this->session->userID);				
					if($userPlayList != null) $this->set('userPlayList',$userPlayList);
				
				$this->set('textToFind',$_REQUEST['textToFind']);
				$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
				$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
				$this->set("lit_song",$this->getLiteral(FR_Util_Literals::LIT_SONG));
				$this->set("lit_choose_playlist",$this->getLiteral(FR_Util_Literals::LIT_CHOOSE_PLAYLIST));
				$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));	     							
			}
	    	else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_RESULT));
	    	
	    	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');    
	    		    	
	    	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
	    	$this->tplFile="searchSong.tpl";     		      		
      }
      catch(PropelException $ex){     	
	     	//echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      }   	
      	
      }
      
      public function includePlayList(){
      	
      	if(AdminPlayList::addSongsToPlayList($this->session->userID)) $this->set("info_message","Se han aadido las canciones al playlist");
      	else $this->set("info_message","No se han aadido las canciones.");      	
      	$this->searchInSong();      
      }
     
    private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
} 
 
 
?>