<?php
/*
 *                        emotion_search.php
 *                    ------------------
 * Creado            : 04-ago-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 class toSearchEmotion extends FR_Auth_No {	
	  
  
      public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
      	
      }
      
      /* Busca las emociones en las canciones */
      public function searchEmotion() {     	
  	
      try{	
      	
      	$emotion = EmotionsPeer::retrieveByPK($_GET['idEmotion']);   		
   		$e_searchs = $emotion->getEmotionSearchs();
   		$emotion_search =  $e_searchs[0];
   		
   		if($emotion_search->getTypefind()!= null || $emotion_search->getPointini()!=null || $emotion_search->getPointfi()!=null || $emotion_search->getInitdate()!=null )
   		{
   			$resultSearch = $this->searchWithCriteria($emotion_search);
   		}
   		else 
   		{
   			$resultSearch = $this->searchWithoutCriteria($emotion_search);
   		}
   		 
   		if($resultSearch) {
   		 
   		 	$this->set('idEmotion',$_GET['idEmotion']);
   		 	$this->set('resultSearch',$resultSearch);
   		 	$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));
   		 	$this->set('max_songs',$emotion_search->getMaxsongs());
   		 	
   		 	$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
			$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));		
			$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
			$this->set("lit_music_elem",$this->getLiteral(FR_Util_Literals::LIT_MUSIC_ELEM));
			$this->set("lit_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));

 	     	$this->set("lit_song",$this->getLiteral(FR_Util_Literals::LIT_SONG));
   		 	$this->set("lit_artist",$this->getLiteral(FR_Util_Literals::LIT_ARTIST));
   		 	$this->set("lit_album",$this->getLiteral(FR_Util_Literals::LIT_ALBUM));
   		 	$this->set("lit_genere",$this->getLiteral(FR_Util_Literals::LIT_GENERE));
   		 	
   		 	/*para montar frase maximo canciones a recuperar de los elementos musicales*/
   		 	$this->set("lit_select_max_songs",$this->getLiteral(FR_Util_Literals::LIT_SELECT_MAX_SONGS));
			$this->set("lit_to_be_selected",$this->getLiteral(FR_Util_Literals::LIT_TO_BE_SELECTED));
   		 	$this->set("lit_songs",strtolower($this->getLiteral(FR_Util_Literals::LIT_SONGS)));
   		 	$this->set('js_file','mod_search.js');
   		}
   		else $this->set("message","NO S'ha encontrado ningun resultado possible.\n 1.associe emociones con elementos musicales\n"); 
   		
   		 	 /* 3 C O L U M N A */
	    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/    	
    		$this->set('3_User_Info_colum','si');    	
      	
      	$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));
      	$this->tplFile="emotionSearch.tpl";
      	   		
      }
      catch(PropelException $ex){
     	
     	echo "ERROR".$ex->getCause();
	    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());
	    unset($emotion); 
	       
      	return false;
      }
      	
    	
      }
      
      /* Busca las emociones que no tienen Criterio*/
      
      public function searchWithoutCriteria(&$emotion_search) {
      	
      	try{
      	
      	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDEMOTION,$_GET['idEmotion']);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		
		$result = split(',',$emotion_search->getFindin()); //Separa la cadena separada por comas (,)
	
		
		if(null != $result[0]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG); 		
		if(null != $result[1]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ARTIST); 		
		if(null != $result[2]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ALBUM); 			
		if(null != $result[3]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_GENERE); 		
		if(null != $result[4]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_PLAYLIST);
			
		 
		

    	$rs = UserUsePlayPeer::doSelect($c);
     
		      
		   if (count($rs) > 0 ) { /* si hay elementos musicales associados a las emociones */
		    	
		    	return $this->getMusicElemFromUserUsePlay($rs);
		    	
		    }/* No se ha encontrado resultado */
		    else return false;      	    		
      	}
      	catch(PropelException $ex){
     		throw PropelException($ex->getCause());     	       
      	return false;
      }
}
      
      /*
       * Coje los elementos que cumplen las condiciones de los metodos
       * 
       * searchWithCriteria
       * searchWithoutCriteria
       *  
       * */
      private function getMusicElemFromUserUsePlay($rs){
     	
     	try{
     			$musicElements = array();
		    	foreach($rs as $object){ 
			    	
			    	if($object->getIdmusicelementtype() == 1) 	{
			    		$result = FR_GetModelObjects::getObjectSong($object->getIdmusicelement());
			    		if($result instanceof Song) 
			    		{
			    			/*echo "type: ".$result->getMusicElementType();
			    			echo "Name:".$result->getSongname();
			    			*/
			    			$musicElements[]=$result;	
			    		}
			    					    			
			    	}			    	
			    	if($object->getIdmusicelementtype() == 2){
			    		$result = FR_GetModelObjects::getObjectArtist($object->getIdmusicelement());
			    	    
			    	    if($result instanceof Artist) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br> type: ".$result->getMusicElementType()->getElementdesc();			    			
			    			echo "Name:".$result->getArtistname();
			    			echo "Songs:".$result->countSongs();*/			    				
			    		}
			    	} 	
			    	if($object->getIdmusicelementtype() == 3){
			    		$result = FR_GetModelObjects::getObjectAlbum($object->getIdmusicelement());
			    	    if($result instanceof Album) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getAlbumname();
			    			echo "Songs:".$result->countSongs();
			    			*/			    				
			    		}
			    		
			    	} 				    	
			    	if($object->getIdmusicelementtype() == 4) 	{
			    		$result = FR_GetModelObjects::getObjectGenere($object->getIdmusicelement());
			    		if($result instanceof Genere) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getGenerename();
			    			echo "Songs:".$result->countSongs();*/
			    				
			    		}
			    			
			    	}
			    	if($object->getIdmusicelementtype() == 5) {
			    		$result = FR_GetModelObjects::getObjectPlayList($object->getIdmusicelement());	
			    	}
		    	}
		    	return $musicElements;
		}
      	catch(PropelException $ex){     		     	       
      		return false;
      	}     
      	
      }	     
      public function searchWithCriteria($emotion_search) {
      	
      try{
      	
      	$c = new Criteria();  
	    		
		$c -> add(UserUsePlayPeer::IDEMOTION,$_GET['idEmotion']);//, 
		$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); /* Usuario ficticio de la aplicacion 1 */
		
		/*Si hi ha entrada unas datas busquem entre las datas F E C H A S */
		if(null != $emotion_search->getInitdate()){
			
			$c -> addAnd(UserUsePlayPeer::FIRSTPLAYDATE,$emotion_search->getInitdate(),Criteria::GREATER_EQUAL); //Mes gran= InitDate 
			$c -> addAnd(UserUsePlayPeer::LASTPLAYDATE,$emotion_search->getFindate(),Criteria::LESS_EQUAL); //Mes petit= Final DAte
		}
		
		/* Si hi ha entrada en  P U N T U A C I O N E S */
		if(0 != $emotion_search->getPointfi()) { /* Con Intervalo */
			
			$c -> addAnd(UserUsePlayPeer::ELEMPUNCTUATION,$emotion_search->getPointini(),Criteria::GREATER_EQUAL); //Mes gran= getPointini
			$c -> addAnd(UserUsePlayPeer::ELEMPUNCTUATION,$emotion_search->getPointfi(),Criteria::LESS_EQUAL); //Mes petit getPointfi			
		}
		else if(0 != $emotion_search->getPointini())  { /* F I J A */
			
			$c -> addAnd(UserUsePlayPeer::ELEMPUNCTUATION,$emotion_search->getPointini(),Criteria::EQUAL); //Mes gran InitDate			
		}
		
		
		$result = split(',',$emotion_search->getFindin()); //Separa la cadena separada por comas (,)
	
		
		if(null != $result[0]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG); 		
		if(null != $result[1]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ARTIST); 		
		if(null != $result[2]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ALBUM); 			
		if(null != $result[3]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_GENERE); 		
		if(null != $result[4]) $c -> addOr(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_PLAYLIST);
		
		$rs = UserUsePlayPeer::doSelect($c);
		
		if (count($rs) > 0 ) { /* si hay elementos musicales associados a las emociones */
		    	
		    	return $this->getMusicElemFromUserUsePlay($rs);
		    	
		}/* No se ha encontrado resultado */
	    else return false; 
		
		
	}catch(PropelException $ex){
     		throw PropelException($ex->getCause()->getMessage());     	       
      	return false;
 }     	
}//final searcWithCriteria
      
/* 3 columna*/ 
  private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
      
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>