<?php
/*
 *                        toSearchObservation.php
 *                    ------------------
 * Creado            : 19-jul-2006
 * Modificado        :
 * Versin           : 1.0
 * Autor             : J.Emilio Navarro
 *
 * Descripcion       : 
 * 
 */
 class toSearchObservation extends FR_Auth_No {
	
	  public function __construct()
      {
          parent::__construct();
      }
      
      public function __default()
      {
      	
      	
      }  
    
     public function showObservationElements(){
     	
     	$result = $this->getObservationElements($_GET['idObservation']);
     	
     	if($result) {
     		
     		$this->set('resultSearch',$result);
     		$this->set('idObservation',$_GET['idObservation']);
     		$this->set('js_file','mod_search.js');
     		$this->set('lit_play',$this->getLiteral(FR_Util_Literals::LIT_PLAY));  
     		
     		/* literales */
     	
	     	$this->set("lit_action_selec",$this->getLiteral(FR_Util_Literals::LIT_ACTION_SELEC));
			$this->set("lit_select_elem",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ELEM));		
			$this->set("lit_select_me_search",$this->getLiteral(FR_Util_Literals::LIT_SELECT_ME_SEARCH));
			$this->set("lit_music_elem",$this->getLiteral(FR_Util_Literals::LIT_MUSIC_ELEM));
			$this->set("lit_name",$this->getLiteral(FR_Util_Literals::LIT_USER_NAME));
			$this->set("lit_song",$this->getLiteral(FR_Util_Literals::LIT_SONG));
   		 	$this->set("lit_artist",$this->getLiteral(FR_Util_Literals::LIT_ARTIST));
   		 	$this->set("lit_album",$this->getLiteral(FR_Util_Literals::LIT_ALBUM));
   		 	$this->set("lit_genere",$this->getLiteral(FR_Util_Literals::LIT_GENERE));   			
     	}
     	else $this->set('not_elements',$this->getLiteral(FR_Util_Literals::LIT_NOT_OBSERV_ASSOCIATED));        	
     	
		$this->set("lit_result",$this->getLiteral(FR_Util_Literals::LIT_RESULT));

		/* 3 C O L U M N A */
    	$this->getNavigationInfoUser(); /* Coje la informacion de navegacion del usuario*/  
	$this->set('3_User_Info_colum','si');  
     	
     	$this->tplFile="eventObservation.tpl";     	
     	
     }
    
      /*
       * Devuelve todos los elementos musicales que tienen associados la observacion
       * x. 
       * */
      public function getObservationElements($idObservation){
      	
      	try{
      		
      		$c = new Criteria();	  		
			$c -> add(UserUsePlayPeer::IDOBSERVATION,$idObservation);//, 
			$c -> addAnd(UserUsePlayPeer::USERID,$this->session->userID); 
			
			$rs = UserUsePlayPeer::doSelect($c);
     
		      
		   if ($rs[0]!= null) { /* si hay elementos musicales associados a las emociones */
		    	
		    	return $this->getMusicElemFromUserUsePlay($rs);
		    	
		    }/* No se ha encontrado resultado */
		    else return false; 
			
      		
      	}
      	catch(PropelException $ex){
     	
	     	echo "ERROR".$ex->getCause();
		    $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause());		    
      	}
      	
      } 
      
       /* Coje los elementos que cumplen las condiciones de los metodos
       * 
       * searchWithCriteria
       * searchWithoutCriteria
       *  
       * */
      private function getMusicElemFromUserUsePlay($rs){
     	
     	try{
     			$musicElements = array();
		    	foreach($rs as $object){ 
			    	
			    	if($object->getIdmusicelementtype() == 1) 	{
			    		$result = FR_GetModelObjects::getObjectSong($object->getIdmusicelement());
			    		if($result instanceof Song) 
			    		{
			    			/*echo "type: ".$result->getMusicElementType();
			    			echo "Name:".$result->getSongname();
			    			*/
			    			$musicElements[]=$result;	
			    		}
			    					    			
			    	}			    	
			    	if($object->getIdmusicelementtype() == 2){
			    		$result = FR_GetModelObjects::getObjectArtist($object->getIdmusicelement());
			    	    
			    	    if($result instanceof Artist) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br> type: ".$result->getMusicElementType()->getElementdesc();			    			
			    			echo "Name:".$result->getArtistname();
			    			echo "Songs:".$result->countSongs();*/			    				
			    		}
			    	} 	
			    	if($object->getIdmusicelementtype() == 3){
			    		$result = FR_GetModelObjects::getObjectAlbum($object->getIdmusicelement());
			    	    if($result instanceof Album) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getAlbumname();
			    			echo "Songs:".$result->countSongs();
			    			*/			    				
			    		}
			    		
			    	} 				    	
			    	if($object->getIdmusicelementtype() == 4) 	{
			    		$result = FR_GetModelObjects::getObjectGenere($object->getIdmusicelement());
			    		if($result instanceof Genere) 
			    		{
			    			$musicElements[] = $result;
			    			/*echo "<br>type: ".$result->getMusicElementType()->getElementdesc();
			    			echo "Name:".$result->getGenerename();
			    			echo "Songs:".$result->countSongs();*/
			    				
			    		}
			    			
			    	}
			    	if($object->getIdmusicelementtype() == 5) {
			    		$result = FR_GetModelObjects::getObjectPlayList($object->getIdmusicelement());	
			    	}
		    	}
		    	return $musicElements;
		}
      	catch(PropelException $ex){     		     	       
      		return false;
      	}     
      	
      }	     
        private function getNavigationInfoUser() {
   	
   		$result = FR_NavigationInfoUser::getNavigationUserEmotions();
   		if($result)   $this->set('userEmotions',$result);   
   		$this->set("lit_select_emotion",$this->getLiteral(FR_Util_Literals::LIT_SELECT_EMOTION));		
   		
   		$result = FR_NavigationInfoUser::getBrowseElements($this->session->idioma);   		
   		if($result) $this->array_set($result);  		
   		
   		unset($result); 
   }
   
   public function getTodayEvents() {
   	
   	  $result=FR_GetModelObjects::getTodayEvents($this->session->userID);
   	  if($result) $this->set('alertAgenda',$result);
   	
   }
       
      
      public function __destruct()
      {
          parent::__destruct();
      }
	
}
?>