<?php
/*
 *                      estadisticas.php
 *                    ------------------
 * Creat            : 09-jun-2006
 * Modificat        :
 * Versi           : 1.0
 * Autor            : J.Emilio Navarro
 *
 * Descripci       : 
 * 
 */
 
 class Stadistics extends FR_Auth_No {
 	
 const LIMIT = 10; /*LIMITE DE CANCIONES EN EL TOP 10*/
 
  function __construct() {
         
         parent::__construct();
  }

   public function __default()
   {

   }
    
   public function  getUrlFrom() {
   	
   	 return "index.php?module=statistics&class=statistics";
   	
   }
   
   /* 
    * Devuelve las canciones mas esuchadas o las menos escuhadas 
    * Action = 0 devuelve las mas escuhadas
    * Action = 1 devuelve las menos escuhadas 
    * */
   public function getListenedSongs($action,$user) {
   	
   	try{
   		
   		$c = new Criteria();
   		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG);		
		if($action==0){
			$c -> addDescendingOrderByColumn(UserUsePlayPeer::COUNTPLAY); /*Mas escuhadas */
		}
		else $c->addAscendingOrderByColumn(UserUsePlayPeer::COUNTPLAY); /*Menos escuhadas */
		 
		$c -> addAnd(UserUsePlayPeer::USERID,$user); /* Usuario ficticio de la aplicacion 1 */
		$c -> setLimit(self::LIMIT);		
	    $rs = UserUsePlayPeer::doSelect($c);     
       
        
	    if ($rs[0]!= null) { /* Si existe pasamos a pantalla*/	    	
	    	$result = array();
	    	$minim = false;
	    	
	    	foreach($rs as $user_play) {	    		
	    		
	    		$song = FR_GetModelObjects::getObjectSong($user_play->getIdmusicelement());
	    		
	    		if($song instanceof Song) {    			
	    			   		
	    			$screenSongs = new FR_Screen();
	    			$screenSongs->setElem($song);
	    			$screenSongs->setCountPlays($user_play->getCountplay());
	    			if($screenSongs->getCountPlays()>0){
	    				$result[]=$screenSongs;
	    				$minim=true;
	    			}     			   		
	    		}    		
	    	}
	    	if($minim) return $result;//$this->set('MostListenedSongs',$rs);    
	    	//echo "RESULTADO CERCA!!".count($rs);
	    }
	    
	    return false;//$this->set('MostListenedSongs',0);
   		
   		
   		
   	}
   	catch(PropelException $ex){   		
   		
   	}  	
   	
   }
   
      /* Devuelve las canciones mas esuchadas o las menos escuhadas 
    * Action = 0 devuelve las mas escuhadas
    * Action = 1 devuelve las menos escuhadas 
    * */
   public function getListenedAlbums($action,$user) {
   	
   	try{
   		
   		$c = new Criteria();
   		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ALBUM);//		
		if($action==0){
			$c -> addDescendingOrderByColumn(UserUsePlayPeer::COUNTPLAY); /*Mas escuhadas */
		}
		else $c->addAscendingOrderByColumn(UserUsePlayPeer::COUNTPLAY); /*Menos escuhadas */
		 
		$c -> addAnd(UserUsePlayPeer::USERID,$user); /* Usuario ficticio de la aplicacion 1 */
		$c -> setLimit(self::LIMIT);		
	    $rs = UserUsePlayPeer::doSelect($c); 
	      
        
	    if ($rs[0]!= null) { /* Si existe pasamos a pantalla*/	    	
	    	$result = array();	 
	    	$minim = false;   	
	    	foreach($rs as $user_play) {	    		
	    		
	    		$album = FR_GetModelObjects::getObjectAlbum($user_play->getIdmusicelement());
	    		
	    		if($album instanceof Album) {    			
	    			   		
	    			$screenSongs = new FR_Screen();
	    			$screenSongs->setElem($album);
	    			$screenSongs->setCountPlays($user_play->getCountplay());
	    			 if($screenSongs->getCountPlays()>0){
	    				$result[]=$screenSongs;
	    				$minim=true;
	    			}     			   		
	    		}    		
	    	}
	    	
	    	if($minim) return $result;//$this->set('MostListenedSongs',$rs);    
	    	//echo "RESULTADO CERCA!!".count($rs);
	    }
	    
	    return false;//$this->set('MostListenedSongs',0);	
   		
   	}
   	catch(PropelException $ex){   		
   		
   	}
   	
   	
   }
   
   /*
    * Devuelve las canciones que tiene la puntuacion maxima,
    * Se utiliza para el contador generico de la aplicacion.
    * */
   public function getMaxSongPuntuation($user) {
   	
   	try{
   	
   		$c = new Criteria();
   		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_SONG);//		
		$c -> addDescendingOrderByColumn(UserUsePlayPeer::ELEMPUNCTUATION); /* Mas escuhadas */		 
		$c -> addAnd(UserUsePlayPeer::USERID,$user); /* Usuario ficticio de la aplicacion 1 */
		$c -> setLimit(self::LIMIT);		
	    $rs = UserUsePlayPeer::doSelect($c); 
	    
	     if ($rs[0]!= null) { /* Si existe pasamos a pantalla*/	    	
	    	$result = array();	
	    	$minim=false;    	
	    	foreach($rs as $user_play) {  		
	    		
	    		$song = FR_GetModelObjects::getObjectSong($user_play->getIdmusicelement());    		
	    		if($song instanceof Song) {    			
	    			   		
	    			$screenSongs = new FR_Screen();
	    			$screenSongs->setElem($song);
	    			$screenSongs->setCountPlays($user_play->getElempunctuation());
	    			if($screenSongs->getCountPlays()>0){
	    				$result[]=$screenSongs;
	    				$minim=true;
	    			}     			   		
	    		}
	    	}	    	
	    	if($minim) return $result;//$this->set('MostListenedSongs',$rs);
	    }
	   
	   return false;//$this->set('MostListenedSongs',0); 
   			
   		
   	}
   	catch(PropelException $ex) {
   		
   		return false;
   		
   	}
   	
   }
   
  public function getMaxArtistPuntuation($user) {
   	
   	try{
   	
   		$c = new Criteria();
   		$c -> add(UserUsePlayPeer::IDMUSICELEMENTTYPE,FR_Util_Const::CONST_ARTIST);//		
		$c -> addDescendingOrderByColumn(UserUsePlayPeer::ELEMPUNCTUATION); /* Mas escuhadas */		 
		$c -> addAnd(UserUsePlayPeer::USERID,$user); /* Usuario ficticio de la aplicacion 1 */
		$c -> setLimit(self::LIMIT);		
	    $rs = UserUsePlayPeer::doSelect($c); 
	    
	     if ($rs[0]!= null) { /* Si existe pasamos a pantalla*/	    	
	    	$result = array();	
	    	$minim=false;    	
	    	foreach($rs as $user_play) {  		
	    		
	    		$artist = FR_GetModelObjects::getObjectArtist($user_play->getIdmusicelement());    		
	    		if($artist instanceof Artist) {    			
	    			   		
	    			$screenSongs = new FR_Screen();
	    			$screenSongs->setElem($artist);
	    			$screenSongs->setCountPlays($user_play->getElempunctuation());
	    			if($screenSongs->getCountPlays()>0){
	    				
	    				$result[]=$screenSongs;	    				
	    				$minim=true;
	    			}  /* Solo si mas grande de 0*/    			   		
	    		}
	    	}
	    	
	    	if($minim) return $result;//$this->set('MostListenedSongs',$rs);	    	
	    }
	    
	    return false;//$this->set('MostListenedSongs',0); 
   			
   		
   	}
   	catch(PropelException $ex) {
   		
   		return false;
   		
   	}
   	
   }
   
 /*
  * Devuelve los albums que se acaban de dar de alta en la aplicacin
  *  
  * */
public function getNewAlbum(){
   	
	   	try{	   	
	   		$c = new Criteria();
	   		//$c -> add(SongPeer::IDALBUM,Criteria::DISTINCT);
	   		$c -> addGroupBycolumn(SongPeer::IDALBUM);   			
   			$c -> addDescendingOrderByColumn(SongPeer::ENTERDATE); /* Mas escuhadas */   		   
			$c -> setLimit(self::LIMIT);		
	    	$rs = SongPeer::doSelect($c);    	
	    	
	    	if ($rs[0]!= null) { /* Si existe pasamos a pantalla*/	    	
	    		
	    		$result = array();	
	    		$minim = false; 		
	    		  	
	    	foreach($rs as $song) {  		
	    		
	    		$album = FR_GetModelObjects::getObjectAlbum($song->getIdAlbum());	    	    		    		
	    		if($album instanceof Album) {	    			
	    		    	  		    	  		
	    	  		$minim=true;		
	    			$result[]=$album;   			    			   		
	    		}
	    	}	    	
	    	if($minim) return $result;
	    }	    
	    	return false;  		
	   	}	   	
	   	catch(PropelException $ex) {   		
	   	 
	  
	   	   $this->showError(FR_Util_Literals::ERROR_DB.$ex->getCause()->getMessage());
	   		return false;	   		
	   	}  	
}
   
    
   public function __destruct()
   {
          parent::__destruct();
   } 
  
}
?>
