<?php

  /**
  * login
  *
  * @author Joe Stump <joe@joestump.net>
  * @copyright Joe Stump <joe@joestump.net>
  * @license http://www.opensource.org/licenses/gpl-license.php 
  * @package Modules
  * @filesource
  */

    require_once('propel/util/Criteria.php');
    include_once('UserConst.php');

  /**
  * login
  *
  * @author Joe Stump <joe@joestump.net>
  * @package Modules
  */
  class login extends FR_Auth_No
  {
      public function __construct()
      {
          parent::__construct();
      }

      public function __default()
      {
         
         if(isset($_REQUEST['language']))    	$this->session->idioma = $_REQUEST['language'];       
         
         /* Hay que controlar si el usuario ja esta loginado.
          * Si es asi no pasamos por login.
          */
         
         if(null != $this->session->userID) { /* La session ha empezado, vamos a pagina principal*/
         	 
         	 $go = 'index.php?module=home';
         	 header("Location: $go");         	
         }
         else {	         					/* hay que iniciar una session*/
	         $this->set("lit_pass",$this->getLiteral(UserConst::LIT_PASS));
			 $this->set("lit_logon",$this->getLiteral(UserConst::LIT_LOGIN));
			 $this->set("lit_register",$this->getLiteral(UserConst::LIT_REGISTER));
	         $this->pageTemplateFile='init.tpl';         	
         }
         
         $this->set('language',$this->session->idioma);  
   	     
			
      }

	  public function login() {
	  	
	  				
	  	if (count($_POST)) {
              $errors = array();
     	
                             
					$user = $this->getUser();
                 
                  if ($user) {
                      
                      if ($user->getActive()) { 								/* USUARI NO BLOQUEJAT */
                          
                          if ($user->getPass() == $_POST['password']) {			/* VALIDACION DE PASSWORD */
                              
                              
                              if (isset($_GET['pg'])) {							/*  Definicion de la pagina que se tiene que cargar 
                              							                            por ejemplo cuando expira la session y hay que entrar
                              	                                                    otra vez.
                              										            */
                                 $go = urldecode($_GET['pg']);
                                 
                              } elseif (isset($_POST['pg'])) {
                                  $go = urldecode($_POST['pg']);
                              } else {
                                  //$go = '/';
                                   $go = 'index.php?module=home';
                                   
                              }
														
								$this->session->userID = $user->getUserid();
								$this->session->idioma = $user->getPreflanguages();
								$this->newUserSession();                                                         
                                header("Location: $go");                              
                                exit();
                              
                          } else {
                              $errors[] = 'Your password is invalid';
                          }
                      } else {
                          $errors[] = 'Your account has been disabled';
                      }
                  
                  
                  } else { 													/* NO EXISTE LOGIN */
                      $errors[] = 'Login does not exist in database';
                  }

			      
			      $this->__default();
                  $this->set('errors',$errors);
              
          }
	  	
	  	
	  }
      
      private function newUserSession() {
      
      try {	
      	$session = new Session();
      	$session -> setIdsession(FR_Session::$sessionID);
      	$session -> setUserid($this->session->userID);
      	$session -> save();
      }catch(PropelException $ex)
      {
      	echo "<br/> newUserSession class LOGIN.php ".$ex->getCause();
      }
      	
      }
      
      private function getUser()
      {
      	
      		$c = new Criteria();		    
			$c -> add(UsersPeer::USERLOGIN,$_POST['login']);			
			$rs = UsersPeer::doSelect($c);		
			      	
      		if(1 == count($rs)) return $rs[0];
      		else return false; /* No existeix login */      	
      }
      

      									
           
      
      public function __destruct()
      {
          parent::__destruct();
      }
  }


?>
